var db = null
,   vPlayerlist = [];
// Ionic Starter App
angular.module('Playlisteiros', ['ionic','ionic.service.core','ionic.service.analytics', 'ionicLazyLoad', 'ngCordova'])
.run(function($ionicPlatform, $rootScope, $cordovaSQLite, $timeout, sessionUser, PlaylisteirosPlayer, $ionicAnalytics){
	$ionicPlatform.ready(function(){
		$ionicAnalytics.register();
		// Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
		// for form inputs)
		if(window.cordova && window.cordova.plugins.Keyboard){
			cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
		}
		if(window.StatusBar){
			StatusBar.styleDefault();
		}

		if(window.Connection){
			if(navigator.connection.type == Connection.NONE){
				$state.go('no-connection');
			}
		}

		/*function midnightNotification() {
			var three = new Date();
			three.setHours( 24 );
			three.setMinutes( 0 );
			three.setSeconds( 0 );
			three.setMilliseconds( 0 );
			var time = (three.getTime() - new Date().getTime())
			,   date = new Date(time + new Date().getTime());
			
			if (time < 0) {
				date.setDate(date.getDate() + 1);
			}

			window.plugin.notification.local.schedule({
				id: 1,
				title: 'Playlist do dia',
				text: 'Participe sugerindo e votando no novo tema de hoje',
				at: date
			});
		};

		function threeNotification() {
			var three = new Date();
			three.setHours( 15 );
			three.setMinutes( 0 );
			three.setSeconds( 0 );
			three.setMilliseconds( 0 );
			var time = (three.getTime() - new Date().getTime())
			,   date = new Date(time + new Date().getTime());
			
			if (time < 0) {
				date.setDate(date.getDate() + 1);
			}

			window.plugin.notification.local.schedule({
				id: 1,
				title: 'Playlist do dia',
				text: 'Participe sugerindo e votando no tema de hoje',
				at: date
			});
		};

		midnightNotification();
		threeNotification();

		cordova.plugins.notification.local.on("trigger", function (notification, state) {
			if (notification.text == 'Participe sugerindo e votando no tema de hoje') {
				threeNotification();
			} else if (notification.text == 'Participe sugerindo e votando no novo tema de hoje') {
				midnightNotification();
			}
		});*/

		$timeout(function(){
			navigator.splashscreen.hide();
		}, 500);

		db = $cordovaSQLite.openDB('playlisteiros.db');
		$cordovaSQLite.execute(db, "CREATE TABLE IF NOT EXISTS info (sessionID text, sessionUser text)");

		$rootScope.user = {};
		sessionUser.checkUserLogged();
	});
	$rootScope.$on('$stateChangeStart', function(event, toState, $stateParams){
		$rootScope.search = false;
	});
})
// Configuração de rotas do Aprenda
.config([
	'$stateProvider', '$urlRouterProvider', '$locationProvider', '$ionicConfigProvider', '$httpProvider', '$ionicAutoTrackProvider',
	function($stateProvider, $urlRouterProvider, $locationProvider, $ionicConfigProvider, $httpProvider, $ionicAutoTrackProvider){
	$ionicConfigProvider.templates.maxPrefetch(0);
	$ionicConfigProvider.views.transition('none');
	// URL padrão de redirecionamento
	$urlRouterProvider.otherwise('/playlisteiros/');
	$ionicAutoTrackProvider.disableTracking('Tap');
	// Configuração das rotas iniciais
	$stateProvider
		.state('menu', {
			'abstract': true,
			templateUrl: 'app/includes/menu.html'
		})
		.state('menu.sugerir',{
			url: '/playlisteiros/sugerir/',
			views: {
				'menuContent': {
					templateUrl: 'app/playlist/sugerir.html',
				}
			}
		})
		.state('menu.ranking',{
			url: '/playlisteiros/ranking/',
			views: {
				'menuContent': {
					templateUrl: 'app/ranking/ranking.html',
				}
			}
		})
		.state('menu.faq',{
			url: '/playlisteiros/faq/',
			views: {
				'menuContent': {
					templateUrl: 'app/faq/faq.html',
				}
			}
		})
		.state('menu.extract',{
			url: '/playlisteiros/extrato/:username',
			views: {
				'menuContent': {
					templateUrl: 'app/extrato/extrato.html',
				}
			}
		})
		.state('menu.playlist', {
			url: '/playlisteiros/',
			views: {
				'menuContent': {
					templateUrl: 'app/playlist/playlist.html',
				}
			}
		})	
		.state('menu.playlistName',{
			url: '/playlisteiros/:playlistName/',
			views: {
				'menuContent': {
					templateUrl: 'app/playlist/playlist.html',
				}
			}
		})
		.state('menu.anteriores',{
			url: '/playlisteiros/anteriores/',
			views: {
				'menuContent': {
					templateUrl: 'app/playlist/anteriores.html',
				}
			}
		})
		.state('menu.anterioresData',{
			url: '/playlisteiros/anteriores/:year/:month/',
			views: {
				'menuContent': {
					templateUrl: 'app/playlist/anteriores.html',
				}
			}
		})

		.state('no-connection',{
			url: '/playlisteiros/no-connection',
			templateUrl: 'app/templates/no-connection.html'
		})

		.state('login', {
			url: '/playlisteiros/login/',
			templateUrl: 'app/auth/login.html'
		})
		.state('register', {
			url: '/playlisteiros/cadastrar/',
			templateUrl: 'app/auth/register.html'
		})
}])

.controller('ConnectionController', [
	'$scope', '$rootScope', '$stateParams', '$state', '$timeout',
	function($scope, $rootScope, $stateParams, $state, $timeout){

	$scope.tryingConn = false;

	$scope.back = function(){
		if ($scope.verifyConnection(false)){
			history.back();
		}else{
			$scope.tryingConn = true;
			$timeout(function(){
				$scope.tryingConn = false;
				history.back();
			},5000)
		}
	}
}])

.controller('MainController', [
	'$scope', '$stateParams', '$rootScope', '$state', 'sessionUser', '$cordovaToast', '$timeout',
	function($scope, $stateParams, $rootScope, $state, sessionUser, $cordovaToast, $timeout){

	$scope.setAvatar = function(obj, section){
		var i
		,   ii = obj.length
		,   lvl2, L, l;

		if (section == "single"){
			lvl2 = obj[0].user_info.lvl - 1;
			L = lvl2-(lvl2%10);
			l = (lvl2%10);

			$scope.isModerator(obj[0]);

			obj[0].lvl1 = L;
			obj[0].lvl2 = l;
		}else{
			for (i = 0; i < ii; i++){
				lvl2 = obj[i].user_info.lvl - 1;
				L = lvl2-(lvl2%10);
				l = (lvl2%10);

				if (section == "comments"){
					if (obj[i].reply_comment != false){
						obj[i].reply_comment.lvl1 = L;
						obj[i].reply_comment.lvl2 = l;
					}
				}
				obj[i].lvl1 = L;
				obj[i].lvl2 = l;
				$scope.isModerator(obj[i]);
			}
		}
	}
	$scope.isModerator = function(obj){
		if (obj.user_info.login == 'leticia' || obj.user_info.login == 'sitevagalume' || obj.user_info.login == 'suportevagalume'){
			obj.moderator = true;
			if (obj.user_info.login == 'sitevagalume' || obj.user_info.login == 'suportevagalume'){
				obj.user_info.user_img = "/images/playlisteiros/logoAvatar.png";
				obj.user_info.name_show = "Vagalume";
			}else if (obj.user_info.login == 'leticia'){
				obj.user_info.name_show = "A. Vagalume";
			}
		}
	}
	$scope.setArtistSmallPic = function(string){
		if (string != null && string != "profilew45"){
			var pic = string.replace("profile","profilew45");
			return pic;
		}
	}
	$scope.setWideArtistPic = function(obj){
		if (obj != null){
			var widePic;
			if (obj.indexOf("profile.jpg") > -1){
				widePic = obj.replace("profile","profile-bigw350");
			}else if (obj.indexOf("profilew45.jpg") > -1){
				widePic = obj.replace("profilew45","profile-bigw350");
			}
			return widePic;
		}
	}
	$scope.verifyConnection = function(sendMessage){
			if(window.Connection){
				if(navigator.connection.type == Connection.NONE){
					if (sendMessage){
						$cordovaToast.showLongCenter('Verifique a conexão com a internet');
					}else{
						$state.go('no-connection');
					}
					return false;
				}
			}
			return true;
	}

	$scope.toast = function(msg){
		$timeout(function(){
			$cordovaToast.showLongBottom(msg);
		},500);
	}
}])

.controller('MenuController', [
	'$scope', '$rootScope', '$location', 'MenuModel', 'sessionUser',
	function($scope, $rootScope, $location, MenuModel, sessionUser){

	$scope.enableSearch = false;
	$scope.suggestData  = { "songs" : [], "search" : '' };

	$scope.menu = {};
	$scope.user = {};
	$scope.searchPlaylist = {};
	$scope.menu.title = "";
	$scope.search = false;

	$rootScope.userInfo = {
		sessionID : null,
		sessionUser : null
	};

	 $rootScope.$on('userLogged', function() {
		$scope.user.isLogged = true;
		sessionUser.load(function(){
			$scope.user = sessionUser.user;
			$scope.user.isLogged = true;
		})
	})

	$rootScope.$on('$stateChangeStart', function(event, toState, $stateParams, state, param){
		// fazer botão back tirar a barrinha de search (caso ativa), ao invés de mudar de página
		if ($scope.search){
			$scope.search = false;
			event.preventDefault();
		}
	});

	$scope.enableSearch = function(){
		$scope.search = !$scope.search ? true : false;
	}
	$scope.setPlaylistsMenu = function(){
		MenuModel
			.setPlaylistsMenu(function(data){
				if (data){
					$scope.menu.yesterdayPlaylist = data.yesterday;
					$scope.menu.todayPlaylist     = data.today;
					$scope.menu.tomorrowPlaylist  = data.tomorrow;
				}
			});
	}
	$scope.suggestPlaylist = function(){
		$scope.verifyConnection(true);
		if ($scope.searchPlaylist.search != ""){
			MenuModel
				.searchPlaylist($scope.searchPlaylist.search, function(data){
					var replace = /^\/[^\/]+\/([^\/.]+)/, str, result;
					for (var i = 0, ii = data.response.docs.length; i < ii; i++){
						str = data.response.docs[i].url;
						if ((result = replace.exec(str)) !== null){
							if (result.index === replace.lastIndex){
								replace.lastIndex++;
							}
						}
						data.response.docs[i].url = result[1];
					}
					if (data.response.numFound > 0){
						$scope.resulSearchPlaylist = data.response.docs;
					}else{
						$scope.resulSearchPlaylist = false;
					}
				});
		}else{
			$scope.resulSearchPlaylist = null;
		}
	}
	$scope.closeSearchPlaylist = function(){
		if (!$scope.resulSearchPlaylist){
			$scope.search = false;
		}
	}
	$scope.removeSearch = function(){
		$scope.search = false;
	}
	$scope.logoff = function(){
		sessionUser.logoff(function(){
			location.reload();
		});
	}
}])

.filter('position', function() {
	return function(value) {
		return value < 10 ? '0' + value : value;
	};
})

.directive('infiniteScroll', function($rootScope, $ionicLoading, $compile) {
	return function(scope, elem, attr) {
		var raw = elem[0];

		elem.bind('scroll', function() {			
			// Carrega mais músicas caso houver			
			if (raw.scrollTop + raw.offsetHeight >= raw.scrollHeight) {
				if ($rootScope.musicsList.length) {

					var father = angular.element(document.getElementById('musicsPlaylist'))
					,   html   = ''
					,   limitedSongs = $rootScope.musicsList.splice(0, 10)
					,   list = document.querySelectorAll('#musicsPlaylist li')
					,   lastPos = parseInt(angular.element(list[list.length-1]).attr('data-pos').slice(0, -1));

					for (var i = 0; i < limitedSongs.length; i++) {
						var music = limitedSongs[i];
						lastPos++;
						html += '<li class="music disable-user-behavior" data-pos="'+(lastPos < 10 ? '0' + lastPos : lastPos)+'°" ng-click="initPlayer('+(lastPos - 1)+');" on-hold="optionsMusic($event, '+(lastPos - 1)+')">'
								+ (music.approved ? '<img class="approved" src="http://s1.vagalume.com/images/playlisteiros2/aprovadas.png">' : '')
								+'<div class="musicName ellipsis">'+music.pointer_name+'</div>'
								+'<div class="artist ellipsis">'+music.band_descr+'</div>'
								+'<i ng-click="vote('+music.playlisteirosID+', '+music.id+')" class="icon ion-thumbsup'+(music.user_vote ? ' positive' : '')+'">'+music.vote_balance+'</i>'
								+'<div ng-click="extractOnClick();" class="avatar L'+music.lvl1+' l'+music.lvl2+' p1" ui-sref="menu.extract({username: '+music.user_info.login+'})" style="background: url(http://s2.vagalume.com'+music.user_info.user_img+') #FFF;">'
								+'<i data-lvl="'+music.user_info.lvl+'"></i>'
								+'</div>'
							+'</li>';
					};
					
					angular.element(list[list.length-1]).after($compile(html)(scope));
				} else {
					var list = document.querySelectorAll('#musicsPlaylist li')
					,   lastPos = angular.element(list[list.length-1]);

					lastPos.addClass('last-li');
				}
			}
		});
	}
})

.controller('PlaylistController', [
	'$scope', '$state', '$stateParams', '$interval', '$timeout', '$ionicPopup', '$ionicModal', '$ionicScrollDelegate', '$rootScope', '$location', '$ionicLoading', 'PlaylistModel', 'PlaylisteirosPlayer', 'MenuModel', '$cordovaSQLite', '$ionicAnalytics', 'sessionUser', '$cordovaVibration', '$compile', '$cordovaLocalNotification',
	function($scope, $state, $stateParams, $interval, $timeout, $ionicPopup, $ionicModal, $ionicScrollDelegate, $rootScope, $location, $ionicLoading, PlaylistModel, PlaylisteirosPlayer, MenuModel, $cordovaSQLite, $ionicAnalytics, sessionUser, $cordovaVibration, $compile, $cordovaLocalNotification){

	var startLoad = function() {
		$ionicLoading.show({template: '<div class=loader><i class="icon ion-load-c"></i></div>', noBackdrop: true});
	}
	,   finishLoad = function() {
		$ionicLoading.hide();
	}

	$scope.musics = $scope.musics ? $scope.musics : [];
	$scope.playlistInfo = [];
	// Tamanho da tela toda menos a soma do topo da playlist com abas (playlist+comentários)
	$scope.scrollHeight = window.innerHeight - 55;
	$scope.comment = {
		msg : ''
	};
	$scope.votes = {
		totalVoted : 0,
		totalToVote : 0,
		totalPermitted : 0
	}
	$scope.selectedItem = {
		item : 'votes'
	};
	$scope.items = [
		{key: 'votes', value: 'Mais votadas'},
		{key: 'alphabetic', value: 'Ordem alfabética'}
	];
	$scope.refreshed = {
		comments : true,
		playlist : true
	}
	$rootScope.vPlayer = {
		controlShow : false,
		currentSong : 0,
		info : null,
		loop : false,
		playerShow : false,
		playlist : null,
		showPlaylist : false,
		shuffle : false
	}

	$rootScope.background = $rootScope.background || {bg : null, saves : {}}

	// Mudar o título do menu, caso a playlist já estiver sido carregada
	$scope.$on('$ionicView.enter', function(){
		$scope.verifyConnection(false);
		PlaylisteirosPlayer.destroyPlayer();

		if ($state.is('menu.playlistName')){
			MenuModel
			.setPlaylistsMenu(function(data){
				if (data){
					var ret = {
						yesterday : data.yesterday,
						today : data.today,
						tomorrow : data.tomorrow
					};

					switch($stateParams.playlistName){
						case ret.yesterday:
							$scope.menu.title = "Playlist de ontem";
							break;
						case ret.today:
							$scope.menu.title = "Playlist de hoje";
							break;
						case ret.tomorrow:
							$scope.menu.title = "Playlist de amanhã";
							break;
						default:
							$scope.menu.title = "Playlisteiros";
							break;
					}
				}
			});

			if ($scope.playlistInfo.id){
				setBackground($rootScope.background.saves[$scope.playlistInfo.id]);
			}
		}
	});

	var getPlaylistToday = function(){
		PlaylistModel
		.getPlaylistUrl("today", function(data){
			if (data && data.success) {	 			
				$state.go('menu.playlistName', {playlistName: data.success}, {notify: false, reload: false})
				getInfoPlaylist();
			}
		});
	}
	,   getInfoPlaylist = function(){
		$scope.verifyConnection(false);		
		PlaylistModel
		.getInfoPlaylist($stateParams.playlistName, function(data){
			if (data.success){
				var playlistInfo = data.success
				,   seconds = playlistInfo.ms_to_finish
				,   headerDOM = document.querySelector('.infoPlaylist')
				,   timer = function(){
						var  days        = Math.floor(seconds/24/60/60)
						,    hoursLeft   = Math.floor((seconds) - (days*86400))
						,    hours       = Math.floor(hoursLeft/3600)
						,    minutesLeft = Math.floor((hoursLeft) - (hours*3600))
						,    minutes     = Math.floor(minutesLeft/60)
						,    remainingSeconds = seconds % 60;

						hours < 10 ? hours = "0" + hours : hours;
						minutes < 10 ? minutes = "0" + minutes : minutes;
						remainingSeconds < 10 ? remainingSeconds = "0" + remainingSeconds : remainingSeconds;

						if (seconds == 0){
							$scope.playlistInfo.elapsedTime = "00:00:00";
							switch(playlistInfo.start_datetime.split(" ")[0]){
								case today:
									$scope.menu.title = "Playlist de ontem";
									break;
								case yesterday:
									$scope.menu.title = "Playlisteiros";
									break;
								case tomorrow:
									$scope.menu.title = "Playlist de hoje";
									break;
							}
							$state.transitionTo($state.current, $stateParams,{
								reload: true,
								inherit: false,
								notify: true
							});
						}else{
							seconds--;
						}
						if (headerDOM.getBoundingClientRect().top < -100){
							return;
						}
						if (seconds <= 300){
							$scope.playlistInfo.elapsedTime = hours + ":" + minutes + ":" + remainingSeconds;
						}else{
							$scope.playlistInfo.elapsedTime = hours + "h " + minutes + "m";
						}
				}

				// Ajustando para template pegar apenas D/M/Y
				playlistInfo.end_datetime_formatted = playlistInfo.end_datetime_formatted.split(' ');
				$scope.playlistInfo = playlistInfo;

				var datePlaylist = playlistInfo.start_datetime.split(" ")[0].replace(/-/g,"/")
				,   date = new Date(datePlaylist)
				,   today = playlistInfo.serverDate
				,   tranformToDate = today.split("-")
				,   todayMS = new Date(tranformToDate[0],tranformToDate[1]-1,tranformToDate[2]).getTime()
				,   yesterday = new Date(todayMS - 1 * 24 * 60 * 60 * 1000).toISOString().slice(0,10)
				,   tomorrow = new Date(todayMS + 1 * 24 * 60 * 60 * 1000).toISOString().slice(0,10);

				switch(playlistInfo.start_datetime.split(" ")[0]){
					case today:
						$scope.when = "today";
						$scope.menu.title = "Playlist de hoje";
						$scope.items.push({key: 'date', value: 'Últimas adicionadas'});
						break;
					case yesterday:
						$scope.when = "yesterday";
						$scope.menu.title = "Playlist de ontem";
						$scope.items.push({key: 'vipvote', value: 'Votos VIP'});
						break;
					case tomorrow:
						$scope.when = "tomorrow";
						$scope.menu.title = "Playlist de amanhã";
						$scope.clickTab("comments");
						break;
					default:
						$scope.when = "other";
						$scope.menu.title = "Playlisteiros";
						$scope.items.push({key: 'vipvote', value: 'Votos VIP'});
						$scope.items.push({key: 'approved', value: 'Aprovadas'});
						break;
				}

				// Setar timeout na playlist
				if ($scope.when == "today" || $scope.when == "tomorrow"){
					$interval(function(){timer();}, 1000);
				}

				getMusics("votes");
			}else{
				getPlaylistToday();
			}
		})
	}

	// Pegar playlist correspondente
	if ($stateParams["playlistName"]){
		getInfoPlaylist();
	} else {
		getPlaylistToday();
	}

	/**
	 * Funções
	 **/

	$rootScope.$on('userLogged', function() {
		getPermittedVotes();
	});

	var getMusics = function(order){
		$scope.verifyConnection(false);
		$scope.musics = [];

		var saveBackground = function(bg){
			$rootScope.background.saves[$scope.playlistInfo.id] = bg;
		}

		PlaylistModel
		.getMusics($scope.playlistInfo.id, order, $rootScope.userInfo.sessionID, $rootScope.userInfo.sessionUser, function(data){
			if (data.success){				
				$scope.votes.totalVoted = 0;

				vPlayerlist = [];
				for (var i = 0, ii = data.success.list.length; i < ii; i++){
					vPlayerlist.push(data.success.list[i]);
					// Pegar votos permitidos do usuário
					if ($rootScope.userInfo.sessionID != null & data.success.list[i].user_vote == 'positive'){
						$scope.votes.totalVoted++;
					}
					// Ajustar acentuação vinda do BD
					encodeURIComponent(data.success.list[i].pointer_name);
					encodeURIComponent(data.success.list[i].band_descr);
				}

				// Setar background da playlist
				setBackground(data.success.list[0].band_img);
				
				// Colocar estilos no avatar
				$scope.setAvatar(data.success.list, null);
				
				// Guardar informação do background
				saveBackground(data.success.list[0].band_img);

				// Colocar músicas na playlist
				var limitedSongs = data.success.list.splice(0, 10);				
				$rootScope.musicsList = data.success.list;				

				var father = angular.element(document.querySelector('#musicsPlaylist'))
				,   html   = '';

				for (var i = 0; i < limitedSongs.length; i++) {
					var music = limitedSongs[i];
					html += '<li class="music disable-user-behavior" data-pos="'+((i+1) < 10 ? '0' + (i+1) : (i+1))+'°" ng-click="initPlayer('+i+');" on-hold="optionsMusic($event, '+i+')">'
							+ (music.approved ? '<img class="approved" src="http://s1.vagalume.com/images/playlisteiros2/aprovadas.png">' : '')
							+'<div class="musicName ellipsis">'+music.pointer_name+'</div>'
							+'<div class="artist ellipsis">'+music.band_descr+'</div>'
							+'<i ng-click="vote('+music.playlisteirosID+', '+music.id+')" class="icon ion-thumbsup'+(music.user_vote ? ' positive' : '')+'">'+music.vote_balance+'</i>'
							+'<div ng-click="extractOnClick();" class="avatar L'+music.lvl1+' l'+music.lvl2+' p1" ui-sref="menu.extract({username: \''+music.user_info.login+'\'})" style="background: url(http://s2.vagalume.com'+music.user_info.user_img+') #FFF;">'
							+'<i data-lvl="'+music.user_info.lvl+'"></i>'
							+'</div>'
						+'</li>';
				};

				father.html(html);
				$compile(father.contents())($scope);				

			} else if (data.error == "Nenhuma música aprovada foi encontrada." || data.error == "Não foram encontradas músicas para esta playlist."){
				setBackground(null);
				$scope.musicMsg = data.error;
				$scope.musics = false;
				$scope.noMusic = true;
			}

			$scope.finishLoad = true;
			$scope.refreshed.playlist = true;
		});
	}
	,   getComments = function(lastCommentID, type, moreComments, cb){
			$scope.verifyConnection(false);
			PlaylistModel
				.getComments($scope.playlistInfo.id, lastCommentID, type, moreComments, function(data){
					if (data.success) {
						$scope.setAvatar(data.success.comments, "comments");
						$scope.lastComment = data.success.comments[data.success.comments.length-1].id;
						$scope.totalTomments = data.success.total_comments;

						if (!moreComments){
							$scope.comments = {};
						}

						if (lastCommentID == 0){
							$scope.comments = data.success.comments;
						} else if (moreComments == true) {
							for (var i = 0; i < data.success.comments.length-1; i++){
								$scope.comments.push(data.success.comments[i]);
							}
						} else {
							$scope.comments.unshift(data.success.comments[0]);
						}

						$scope.refreshed.comments = true;						
						cb && cb();
						return true;
					} else {
						$scope.refreshed.comments = true;						
						return false;
					}
				})
	}	
	,   getPermittedVotes = function(){
			if ($rootScope.userInfo.sessionID){
				var totalPermittedVotes = Math.ceil(vPlayerlist.length * 0.05);

				if (totalPermittedVotes > 30){
					totalPermittedVotes = 30;
				}
				$scope.votes.totalPermitted = totalPermittedVotes;
				$scope.votes.totalToVote = totalPermittedVotes - $scope.votes.totalVoted;
			}
	}
	,   setBackground = function(scope){
		if (scope){
			$rootScope.background.bg = "http://s2.vagalume.com"+$scope.setWideArtistPic(scope);
		} else {
			$rootScope.background.bg = null;
		}
	}
	,   insertBgInfo = function(playlist, bg){
			var query = "INSERT INTO info (background) VALUES (?)";
			$cordovaSQLite.execute(db, query, [window.background[playlist] = bg]);
	}

	/**
	 * Ações
	 **/

	$scope.scroll = {
		position : null,
		playlistHeader : 0
	}
	$scope.closeKeyboardOnEnter = function(keyEvent){
		if (keyEvent.which === 13 && ionic.keyboard.isOpen){
			ionic.keyboard.hide();
		}
	}
	$scope.showCommentInput = function(){
		var scrollHandle = $scope.activeTab == 'songs' ? 'scrollPlaylist' : 'scrollComments';
		$ionicScrollDelegate.$getByHandle(scrollHandle).scrollTo(0, 1);
		$timeout(function(){
			$scope.$apply();
		},500);
	}
	$scope.displayHideAddMusicButton = function(){
		$scope.addMusicButtom = !$scope.addMusicButtom ? true : false;
	}
	$scope.getScrollPos = function(){		
		/*var scrollHandle = $scope.activeTab == 'songs' ? 'scrollPlaylist' : 'scrollComments'
		,   controlShowHeight = $scope.vPlayer.controlShow ? 55 : 0;
		$scope.scroll.position = $ionicScrollDelegate.$getByHandle(scrollHandle).getScrollPosition().top;

		// Altura da janela de playlist/comentário
		if ($scope.scroll.position > 0){
			$scope.scrollHeight = window.innerHeight - 104 - controlShowHeight;
			$scope.scroll.playlistHeader = 150;
		}else{
			$scope.scrollHeight = window.innerHeight - 55 - controlShowHeight;
			$scope.scroll.playlistHeader = 0;
		}*/
	}
	$scope.scrollToTop = function(){
		var scrollHandle = $scope.activeTab == 'songs' ? 'scrollPlaylist' : 'scrollComments';
		$ionicScrollDelegate.$getByHandle(scrollHandle).scrollTop(true);
	}
	$scope.scrollToBottom = function(){
		var scrollHandle = $scope.activeTab == 'songs' ? 'scrollPlaylist' : 'scrollComments';
		$ionicScrollDelegate.$getByHandle(scrollHandle).scrollBottom(true);
	}
	$scope.addComment = function(){
		if (!$scope.verifyConnection(true)){
			return false;
		}
		if (!$rootScope.userInfo.sessionID){
			$scope.toast("Faça o login para comentar");
			return false;
		}
		if (!$scope.comment.msg){
			$scope.toast("Escreva algum comentário");
			return false;
		}

		startLoad();
		PlaylistModel
			.addComment($scope.comment.msg, $scope.playlistInfo.id, $scope.lastComment, $rootScope.userInfo.sessionID, $rootScope.userInfo.sessionUser, function(data){
				if (data.success){
					$ionicAnalytics.track('Playlisteiros / Comentário');
					$scope.setAvatar(data.success.comments, "single");
					$scope.comments.unshift(data.success.comments[0]);
					$scope.comment.msg = null;
				}else{
					$scope.toast(data.error);
				}
				finishLoad();
			})
	}
	$scope.changeFilter = function(){
		if (!$scope.verifyConnection(true)){
			return false;
		}
		$scope.finishLoad = false;
		getMusics($scope.selectedItem.item);
	}
	$scope.activeTab = 'songs';
	$scope.commentsLoaded = false;
	$scope.clickTab = function(action){
		var scrollHandle = $scope.activeTab == 'comments' ? 'scrollPlaylist' : 'scrollComments';		
		$scope.activeTab = action;
		if ($scope.activeTab == "comments"){
			if (!$scope.commentsLoaded){
				getComments(0, "last", false);
			}
			$scope.commentsLoaded = true;
		}
	}
	$scope.moreComments = function(){
		if (!$scope.verifyConnection(true)){
			return false;
		}
		getComments($scope.lastComment, "before", true);
	}
	$scope.refreshPlaylist = function(){
		if (!$scope.verifyConnection(true)){
			return false;
		}
		var tab = $scope.activeTab;
		if (tab == "comments"){
			$scope.refreshed.comments = false;
			getComments(0, "last", false);
		}else if (tab == "songs"){
			$scope.refreshed.playlist = false;
			getMusics($scope.selectedItem.item);
		}
	}
	$scope.buildToken = function(){
		if (!$rootScope.user.isLogged) {
			return false;
		}
		$scope.verifyConnection(false);
		PlaylistModel
			.buildToken($scope.playlistInfo.id, $rootScope.userInfo.sessionID, $rootScope.userInfo.sessionUser, function(data){
				if (data){
					$scope.token = data;
				}
			})
	};
	$scope.vote = function(playlistID, vinculoID){
		if (!$scope.verifyConnection(true)){
			return false;
		}
		if ($scope.when != "today"){
			$scope.toast("A playlist já foi finalizada");
			event.stopPropagation();
			return;
		}else if ($rootScope.userInfo.sessionID == null){
			$scope.toast("Faça o login para votar");
			event.stopPropagation();
			return;
		}

		PlaylistModel
			.computeVote(playlistID, vinculoID, "positive", $rootScope.userInfo.sessionID, $rootScope.userInfo.sessionUser, "music", function(data){
				if (data.success){
					$ionicAnalytics.track('Playlisteiros / Voto');
					$scope.votes.totalToVote--;
					for (var i = 0, j=$scope.musics.length; i < j; i++){
						if($scope.musics[i].id == vinculoID){
							$scope.musics[i].vote_balance++;
							$scope.musics[i].user_vote = "positive";
						}
					};
				}else{
					$scope.toast(data.error);
				}
			})
		event.stopPropagation();
	}
	// Ir para extrato sem iniciar o player
	$scope.extractOnClick = function(){
		event.stopPropagation();
	}
	function reportMusic(musicID, login){
		if (!$scope.verifyConnection(true)){
			return false;
		}
		if ($rootScope.userInfo.sessionID == null){
			$scope.toast("Faça o login para denunciar");
			return false;
		}else{
			var delation = prompt("Motivo da denúncia", "");
			if (delation == null){
				return;
			}else if (delation == ""){
				$scope.toast("Escreva o motivo da denúncia");
				return;
			}
		}

		startLoad();
		PlaylistModel
			.denunciateMusic(musicID, $scope.playlistInfo.id, login, delation, $rootScope.userInfo.sessionID, $rootScope.userInfo.sessionUser, function(data){
				if (data.success){
					$ionicAnalytics.track('Playlisteiros / Denúncia música');
					$scope.toast("Sua denúncia foi enviada");
				}else{
					$scope.toast(data.error);
				}
				finishLoad();
			})
	};

	/**
	 * PopUps
	 **/

	$scope.respPopup = function(obj){
		$scope.respComment = {};

		var respPopup = $ionicPopup.show({
			title: 'Responder comentário',
			subTitle: 'Respondendo '+obj.user_info.name_show,
			template: '<textarea ng-model="respComment.resp" name=respComment class=resp placeholder="Escreva a sua mensagem..."></textarea>',
			cssClass: 'respPopup',
			scope: $scope,
			buttons: [
				{
					text: 'Responder',
					type: 'button-button-full btn',
					onTap: function(e){
						if (!$scope.verifyConnection(true)){
							return false;
						}
						startLoad();
						PlaylistModel
							.respComment($scope.respComment.resp, obj.id, obj.id, $scope.playlistInfo.id, $rootScope.userInfo.sessionID, $rootScope.userInfo.sessionUser, obj.user_info.login, function(data){
								if (data.success){
									$ionicAnalytics.track('Playlisteiros / Comentário');
									$scope.setAvatar(data.success.comments, "single");
									$scope.comments.unshift(data.success.comments[0]);
								}else{
									$scope.toast(data.error);
								}
								finishLoad();
							})
					}
				},
				{
					text: 'Cancelar',
					type: 'button-button-full btn darkbg',
					onTap: function(e){
						respPopup.close();
					}
				},
			]
		});

		$timeout(function() {
			document.querySelector('.respPopup textarea').focus();
		}, 700);
	};

	$scope.commentPopup = function(obj){
		sessionUser.load(function(){
			var buttons = []
			,   tempBtn = []
			,   loggedUser = sessionUser.user.login;

			$scope.respComment = {};

			if(loggedUser == obj.user_info.login){
				tempBtn = {
							text: 'Remover',
							type: 'button-button-full btn',
							onTap: function(e){
								if (!$scope.verifyConnection(true)){
									return false;
								}
								PlaylistModel
									.removeComment($scope.playlistInfo.id, obj.id, $rootScope.userInfo.sessionID, $rootScope.userInfo.sessionUser, function(data){
										if (data.success){
											$scope.toast("Comentário removido");
											getComments(0, "last", false);
										}else{
											$scope.toast(data.error);
										}
									});
							}
						}
				buttons.push(tempBtn);
			}else{
				tempBtn = [
					{
						text: 'Ignorar usuário',
						type: 'button-button-full btn',
						onTap: function(e){
							ignore.consider(loggedUser, obj.user_info.login, obj.user_info.name_show, "none");
							// Falta esconder os comentários ignorados e tirar o ignored
						}
					},
					{
						text: 'Denunciar usuário',
						type: 'button-button-full btn',
						onTap: function(e){
							var delation = prompt("Motivo da denúncia", "");
							if (!$scope.verifyConnection(true)){
								return false;
							}
							PlaylistModel
								.denunciateUser(obj.id, $scope.playlistInfo.id, obj.user_info.login, delation, $rootScope.userInfo.sessionID, $rootScope.userInfo.sessionUser, function(data){
									if (data.success){
										$ionicAnalytics.track('Playlisteiros / Denúncia Comentário');
										$scope.toast("Sua denúncia foi enviada");
									}else{
										$scope.toast(data.error);
									}
								})
						}
					}
				]
				buttons.push(tempBtn[0]);
				buttons.push(tempBtn[1]);
			}

			tempBtn = {
						text: 'Cancelar',
						type: 'button-button-full darkbg',
						onTap: function(e){
							commentPopup.close();
						}
					}
			buttons.push(tempBtn);

			var commentPopup = $ionicPopup.show({
				title: 'Opções',
				cssClass: 'commentPopup',
				scope: $scope,
				buttons: buttons
			});
		})
	};

	$scope.optionsMusic = function($event, obj){
		$cordovaVibration.vibrate(200);

		var fullUrl = "http://m.vagalume.com.br/playlisteiros/"+$stateParams.playlistName
		,   sharePopup = $ionicPopup.show({
			title: 'Compartilhar playlist',
			cssClass: 'sharePopup',
			buttons: [
				{
					text: 'Facebook',
					type: 'button-button-full btn',
					onTap: function(e){
						$scope.verifyConnection(false);
						$ionicAnalytics.track('Playlisteiros / Share Facebook');
						window.open("http://www.facebook.com/share.php?u="+fullUrl,
							"", "menubar=no, toolbar=no, location=no, scrollbars=yes, scrolling=yes");
						// Ajustar/melhorar link de compartilhamento
					}
				},
				{
					text: 'Twitter',
					type: 'button-button-full btn',
					onTap: function(e){
						$scope.verifyConnection(false);
						var msg = encodeURIComponent("Ajude votando para esta ser a próxima playlist no Vagalume Playlisteiros!")
						$ionicAnalytics.track('Playlisteiros / Share Twitter');
						window.open("http://twitter.com/share?text="+msg+"&url="+fullUrl,
							"", "menubar=no, toolbar=no, location=no, scrollbars=yes, scrolling=yes");
						// Ajustar/melhorar link de compartilhamento
					}
				},
				{
					text: 'Google+',
					type: 'button-button-full btn',
					onTap: function(e){
						$scope.verifyConnection(false);
						$ionicAnalytics.track('Playlisteiros / Share Google+');
						window.open("https://plus.google.com/share?url="+fullUrl,
							"", "menubar=no, toolbar=no, location=no, scrollbars=yes, scrolling=yes");
						// Ajustar/melhorar link de compartilhamento
					}
				},
				{
					text: 'Denunciar música',
					type: 'button-button-full btn',
					onTap: function(e){
						if (!$scope.verifyConnection(true)){
							return false;
						}
						reportMusic(obj.id, obj.user_info.login);
					}
				},
				{
					text: 'Cancelar',
					type: 'button-button-full btn darkbg',
					onTap: function(e){
						sharePopup.close();
					}
				},
			]
		});
		event.stopPropagation();
	};

	/**
	 * Modals
	 **/

	$scope.modal = null;
	$scope.searchSuggest = {};
	$scope.songs = {};
	$ionicModal.fromTemplateUrl('app/templates/suggestMusic.html',{
		scope: $scope,
		animation: 'slide-in-up'
	}).then(function(modal){
		$scope.modal = modal;
	});

	$scope.doSuggest = function(){
		if (!$rootScope.user.isLogged) {
			$state.go('login');
			return false;
		}
		var openModal = function() {
			$scope.modal.show();
		};
		var closeModal = function() {
			$scope.modal.hide();
		};
		$scope.addMusicToPlaylist = function(musicID){
			if (!$scope.verifyConnection(true)){
				return false;
			}
			startLoad();
			PlaylistModel
				.addMusicToPlaylist($scope.playlistInfo.id, musicID, $scope.token, $rootScope.userInfo.sessionID, $rootScope.userInfo.sessionUser, function(data){
					if (data.success){
						$scope.selectedItem.item = "date";
						$ionicAnalytics.track('Playlisteiros / Sugerir música');
						getMusics("date");
						closeModal();

						var now = new Date().getTime()
						,   _30MinFromNow = new Date(now + 60000 * 30);

						window.plugin.notification.local.schedule({
							id: 1,
							title: 'Playlist do dia',
							text: 'Você já pode adicionar uma nova música',
							at: _30MinFromNow
						});
					}else{
						$scope.toast(data.error);
						closeModal();
					}
					finishLoad();
				})
		};
		$scope.suggest = function(){
			if (!$scope.verifyConnection(true)){
				return false;
			}
			function getBandImage(obj){
				if (obj != null || obj != undefined){
					for (var key in obj){
						var artistName = obj[key].url.split(/[//]/)[1]
						,   artistImage = artistName;
						obj[key].band_img = "/"+artistName+"/images/profile.jpg";
					}
				}
			}
			PlaylistModel
				.suggest($scope.searchSuggest.s, function(data){
					if (data){
						$scope.songs.s = data.response.docs;
						getBandImage($scope.songs.s);
					}
				})
		};
		$scope.upSuggest = function() {
			$scope.suggestFocused = true;
		}
		$scope.downSuggest = function() {
			$scope.suggestFocused = false;
		}
		openModal();
		$scope.$on('$destroy', function() {
			$scope.modal.remove();
		});
	}

	/**
	 * Player
	 **/

	$rootScope.initPlayer = function(pos){
		var obj = vPlayerlist[pos];
		if (!$scope.verifyConnection(true)){
			return false;
		}

		$rootScope.finishLoad = false;
		$timeout(function(){
			var vPlayer = document.querySelector(".vPlayer")
			,   infoInitPlayer = {};

			// Se não existir o vPlayer, crie
			if (vPlayer == null){
				var infoShow = {};

				if (obj == null){
					// Tocar a playlist desde o início
					var musicName = document.querySelector(".musicName")
					,   artistName = document.querySelector(".artistName");

					infoInitPlayer = {
						band: artistName.innerHTML,
						bandID: artistName.getAttribute('data-bandid'),
						service: 'youtube',
						source: musicName.getAttribute('data-ytid'),
						title: musicName.innerHTML
					}
					infoShow = {
						music : musicName.innerHTML,
						artist : artistName.innerHTML,
						bandImg : obj.band_img
					}
				}else{
					// Tocar a playlist selecionando um artista específico
					infoInitPlayer = {
						band: obj.band_descr,
						bandID: 0,
						service: 'youtube',
						source: '',
						title: obj.pointer_name
					}
					infoShow = {
						music : obj.pointer_name,
						artist : obj.band_descr,
						bandImg : obj.band_img
					}
				}
				// Pega/muda a música e artista que está tocando no momento
				setNowPlaying(infoShow);
				PlaylisteirosPlayer.initPlayer(infoInitPlayer);
			}else{
				// Se o player já estiver aberto, mudar música no click
				var infoShow = {
					artist: obj.band_descr,
					music: obj.pointer_name,
					bandImg : obj.band_img
				}
				// Pega/muda a música e artista que está tocando no momento
				setNowPlaying(infoShow);
				PlaylisteirosPlayer.playSelectedMusic(infoShow);
				$rootScope.vPlayer.controlShow = false;
			}
			$ionicAnalytics.track('Playlisteiros / vPlayer');
			// Deixar imagem de "tocando agora" pequena
			if (Object.keys(infoShow).length > 0){
				$rootScope.vPlayer.controlImage = infoShow.bandImg;
			}
			if ($scope.vPlayer.showPlaylist){
				$scope.vPlayer.showPlaylist = false;
			}
			$scope.vPlayer.playerShow = true;
		}, 1);
	}

	function setNowPlaying(info){
		$rootScope.vPlayer.info = {
			music: info.music,
			artist: info.artist,
			bandImg : info.bandImg
		}
	}
}])

.controller('PlayerController', [
	'$scope', '$stateParams', '$ionicPopup', '$rootScope', 'PlaylistModel', 'PlaylisteirosPlayer', '$timeout',
	function($scope, $stateParams, $ionicPopup, $rootScope, PlaylistModel, PlaylisteirosPlayer, $timeout){

	$scope.blockButton = false;

	$scope.tempDisableButtons = function(btn){
		var isBlock = angular.element(document.querySelector("."+btn)).hasClass('block');

		if (!isBlock){
			$timeout(function(){
				$scope.blockButton = true;
			}, 100);
			$timeout(function(){
				$scope.blockButton = false;
			}, 1000);
		}
	}

	$scope.showAndHidePlayer = function(){
		var player = $rootScope.vPlayer;
		if (player.playerShow){
			player.playerShow = false;
			player.controlShow = true;

			var playerDIV = document.getElementById('playerArea2')
			,   playerBtn = angular.element(document.querySelectorAll(".playPause"));
			
			playerObj = playerDIV.vPlayer;
			playerObj.pause();
			angular.element(playerBtn).removeClass('ion-pause').addClass('ion-play');
		}else{
			player.playerShow = true;
			player.controlShow = false;
		}
	}
	$scope.loop = function(){
		var player = $rootScope.vPlayer;
		if (player.loop){
			player.loop = false;
		}else{
			player.loop = true;
		}
	}
	$scope.shuffle = function(){
		var player = $rootScope.vPlayer;
		if (player.shuffle){
			player.shuffle = false;
		}else{
			player.shuffle = true;
		}
	}
	$scope.playSong = function(){
		$scope.tempDisableButtons('playPause');
		if ($scope.blockButton){
			return false;
		}
		$scope.verifyConnection(false);
		PlaylisteirosPlayer.playAndPauseSong();
	}
	$scope.playAndShow = function(){
		$scope.playSong();
		$scope.showAndHidePlayer();
	},
	$scope.rewind = function(){
		$scope.tempDisableButtons('ion-ios-rewind');
		if ($scope.blockButton){
			return false;
		}
		$scope.verifyConnection(false);
		PlaylisteirosPlayer.rewind();
	}
	$scope.forward = function(){
		$scope.tempDisableButtons('ion-ios-fastforward');
		if ($scope.blockButton){
			event.stopPropagation();
			return false;
		}
		$scope.verifyConnection(false);
		PlaylisteirosPlayer.forward();
	}
	$scope.seekTo = function(e){
		var barWidth = document.getElementById("progressBar").offsetWidth;
		$rootScope.barPercent = (e.offsetX * 100) / barWidth;
		PlaylisteirosPlayer.seekProgressBar($rootScope.barPercent);
	}

	var rootScopeEventMap = {};

	rootScopeEventMap['player.ready'] = $rootScope.$on('player.ready', function(playerObj){
		($rootScope.vPlayer = $rootScope.vPlayer || {}).playerShow = true;
	});

	$scope.$on('$destroy', function(){
		for(var key in rootScopeEventMap){
			rootScopeEventMap[key]();
		}
	})
}])

.controller('VPlayer',
['$scope', 'PlaylisteirosPlayer',
function($scope, PlaylisteirosPlayer){}])

.controller('NextPlaylistController', [
	'$scope', '$rootScope', '$stateParams', '$ionicPopup', '$ionicModal', '$ionicLoading', 'PlaylistModel', 'sessionUser', 'LoginModel', '$ionicAnalytics', '$cordovaVibration',
	function($scope, $rootScope, $stateParams, $ionicPopup, $ionicModal, $ionicLoading, PlaylistModel, sessionUser, LoginModel, $ionicAnalytics, $cordovaVibration){

	$scope.suggest = {
		playlist : "",
		rule : ""
	};
	$scope.selectedItem = {};
	$scope.selectedItem.item = 'votes';
	$scope.items = [
		{key: 'votes', value: 'MAIS VOTADAS'},
		{key: 'alphabetic', value: 'ORDEM ALFABÉTICA'},
		{key: 'date', value: 'ÚLTIMAS ADICIONADAS'}
	];

	var startLoad = function() {
		$ionicLoading.show({template: '<div class=loader><i class="icon ion-load-c"></i></div>', noBackdrop: true});
	}
	,   finishLoad = function() {
		$ionicLoading.hide();
	}

	$scope.$on('$ionicView.enter', function(){
		$scope.verifyConnection(false);
		$scope.menu.title = "Próximas playlists";
		getSuggestedPlaylists("votes");

		var userLogged = $rootScope.$on('userLogged', function() {
			// Pegar as informações do usuário logado
			sessionUser.load(function(){
				LoginModel
					.getUserlevel($rootScope.userInfo.sessionID, $rootScope.userInfo.sessionUser, function(data){
						sessionUser.user.lvl = data.success;
						// Cor na barrinha de level
						var lvl2, L, l;
						lvl2 = sessionUser.user.lvl - 1;
						L = lvl2-(lvl2%10);
						l = (lvl2%10);
						sessionUser.user.lvl1 = L;
						sessionUser.user.lvl2 = l;
						sessionUser.user.userImg = "/dynimage_user/"+sessionUser.user.user_photo+".jpg";

						if (sessionUser.user.login == 'leticia' || sessionUser.user.login == 'sitevagalume' || sessionUser.user.login == 'suportevagalume'){
							sessionUser.user.moderator = true;
							if (sessionUser.user.login == 'sitevagalume' || sessionUser.user.login == 'suportevagalume'){
								sessionUser.user.userImg = "/images/playlisteiros/logoAvatar.png";
							}
						}
					});
				$rootScope.loginInfo = sessionUser.user;
			})
		});
	})

	startLoad();
	function getSuggestedPlaylists(filter){
		$scope.playlists = {};
		PlaylistModel
			.getSuggestedPlaylists(filter, $rootScope.userInfo.sessionID, $rootScope.userInfo.sessionUser, function(data){
				if (data.success){
					var lvl2, L, l;
					// Cor na barra e level do usuário
					for (var i = 0, ii = data.success.length; i < ii; i++){
						lvl2 = data.success[i].user_info.lvl - 1;
						L = lvl2-(lvl2%10);
						l = (lvl2%10);
						if (data.success[i].user_info.name_show == null){
							data.success[i].user_info.name_show = "null";
						}
						data.success[i].lvl1 = L;
						data.success[i].lvl2 = l;
					}

					for (var key in data.success){
						data.success[key].showRules = false;
					}
					$scope.playlists = data.success;
					finishLoad();
				}
			})
	}

	$scope.showRules = function(key){
		$scope.playlists[key].showRules = true;
	}
	$scope.changeFilter = function(){
		if (!$scope.verifyConnection(true)){
			return false;
		}
		startLoad();
		getSuggestedPlaylists($scope.selectedItem.item);
	}
	$scope.vote = function(playlistID){
		if (!$scope.verifyConnection(true)){
			return false;
		}
		PlaylistModel
			.computeVote(playlistID, false, "positive", $rootScope.userInfo.sessionID, $rootScope.userInfo.sessionUser, "playlist", function(data){
				if (data.success){
					$ionicAnalytics.track('Playlisteiros / Voto');
					for (var i = 0, ii = $scope.playlists.length; i < ii; i++){
						if($scope.playlists[i].id == playlistID){
							$scope.playlists[i].vote_balance++;
							$scope.playlists[i].user_vote = "positive";
						}
					};
				}else{
					$scope.toast(data.error);
				}
			})
	}
	$scope.addPlaylist = function(){
		if (!$scope.verifyConnection(true)){
			return false;
		}
		if ($scope.suggest.playlist.length == 0){
			$scope.toast("Insira um nome para a sugestão de playlist");
			return;
		}

		startLoad();
		PlaylistModel
			.addPlaylist($scope.suggest.playlist, $scope.suggest.rule, $rootScope.userInfo.sessionID, $rootScope.userInfo.sessionUser, function(data){
				if (data.success){
					$scope.selectedItem.item = 'date';
					getSuggestedPlaylists("date");
					$scope.modal.hide();
				}else{
					$scope.modal.hide();
					$scope.toast(data.error);
					finishLoad();
				}
			})
	}
	$scope.rulesMaxLength = function(){
		var maxLength = 200
		,   value = $scope.suggest.rule
		if (value.length > maxLength){
			$scope.suggest.rule = value.substr(0,maxLength);
		}
	}
	$scope.optionsPlaylist = function(obj){
		$cordovaVibration.vibrate(200);

		var fullUrl = "http://m.vagalume.com.br/playlisteiros/sugerir/#"+obj.id
		,   sharePopup = $ionicPopup.show({
			title: 'Compartilhar playlist',
			cssClass: 'sharePopup',
			buttons: [
				{
					text: 'Facebook',
					type: 'button-button-full btn',
					onTap: function(e){
						$scope.verifyConnection(false);
						$ionicAnalytics.track('Playlisteiros / Share Facebook');
						window.open("http://www.facebook.com/share.php?u="+fullUrl,
							"", "menubar=no, toolbar=no, location=no, scrollbars=yes, scrolling=yes");
						// Ajustar/melhorar link de compartilhamento
					}
				},
				{
					text: 'Twitter',
					type: 'button-button-full btn',
					onTap: function(e){
						$scope.verifyConnection(false);
						var msg = encodeURIComponent("Ajude votando para esta ser a próxima playlist no Vagalume Playlisteiros!")
						$ionicAnalytics.track('Playlisteiros / Share Twitter');
						window.open("http://twitter.com/share?text="+msg+"&url="+fullUrl,
							"", "menubar=no, toolbar=no, location=no, scrollbars=yes, scrolling=yes");
						// Ajustar/melhorar link de compartilhamento
					}
				},
				{
					text: 'Google+',
					type: 'button-button-full btn',
					onTap: function(e){
						$scope.verifyConnection(false);
						$ionicAnalytics.track('Playlisteiros / Share Google+');
						window.open("https://plus.google.com/share?url="+fullUrl,
							"", "menubar=no, toolbar=no, location=no, scrollbars=yes, scrolling=yes");
						// Ajustar/melhorar link de compartilhamento
					}
				},
				{
					text: 'Cancelar',
					type: 'button-button-full btn darkbg',
					onTap: function(e){
						sharePopup.close();
					}
				},
			]
		});
	};

	$ionicModal.fromTemplateUrl('app/templates/suggestPlaylist.html', {
		scope: $scope,
		animation: 'slide-in-up'
	}).then(function(modal) {
		$scope.modal = modal;
	});

	$scope.openModal = function() {
		$scope.modal.show();
	};
	$scope.closeModal = function() {
		$scope.modal.hide();
	};
	$scope.$on('$destroy', function() {
		$scope.modal.remove();
	});
}])

.controller('AnteriorController', [
	'$scope', '$state', '$rootScope', '$stateParams', '$location', '$ionicLoading', 'PlaylistModel',
	function($scope, $state, $rootScope, $stateParams, $location, $ionicLoading, PlaylistModel){
	var date = new Date()
	,   key
	,   months = {'Jan':'01', 'Fev':'02', 'Mar':'03', 'Abr':'04', 'Mai':'05', 'Jun':'06', 'Jul':'07', 'Ago':'08', 'Set':'09', 'Out':'10', 'Nov':'11', 'Dez':'12'}
	,   fullMonths = {'Jan':'Janeiro', 'Fev':'Fevereiro', 'Mar':'Março', 'Abr':'Abril', 'Mai':'Maio', 'Jun':'Junho', 'Jul':'Julho', 'Ago':'Agosto', 'Set':'Setembro', 'Out':'Outubro', 'Nov':'Novembro', 'Dez':'Dezembro'}
	,   stringMonth = ['Janeiro','Fevereiro','Março','Abril','Maio','Junho','Julho','Agosto','Setembro','Outubro','Novembro','Dezembro']
	$scope.years = [];
	$scope.months = [];

	var startLoad = function() {
		$ionicLoading.show({template: '<div class=loader><i class="icon ion-load-c"></i></div>', noBackdrop: true});
	}
	,   finishLoad = function() {
		$ionicLoading.hide();
	}

	$scope.$on('$ionicView.enter', function(){
		$scope.verifyConnection(false);
		$scope.menu.title = "Todas as playlists";
	})

	if (!verifyDateOnInit()){
		return;
	}

	startLoad();
	PlaylistModel
		.anteriores($stateParams.year, $stateParams.month, function(data){
			var date = new Date();
			if ($location.path() == '/playlisteiros/anteriores/'){
				$scope.selectedYear = date.getFullYear();
				$scope.selectedMonth = "0"+(date.getMonth()+1);
			}else{
				$scope.selectedYear = parseInt($stateParams.year);
				$scope.selectedMonth = $stateParams.month;
			}

			$scope.setAvatar(data.playlists, null);

			// Coloca os anos no select
			for (var i = 0, ii = data.menuYears.length; i < ii; i++){
				$scope.years.push({key: parseInt(data.menuYears[i]), value: parseInt(data.menuYears[i])});
			}

			// Coloca os meses no select
			for (key in data.topMenu){
				if (data.topMenu[key].active == true){
					$scope.months.push({key:months[data.topMenu[key].descr], value:fullMonths[data.topMenu[key].descr]});
				}
			}

			// Substituir iniciais de mês pelo nome inteiro. Ex: Jan = Janeiro
			for (var key in data.playlists){
				data.playlists[key].month_descr = fullMonths[data.playlists[key].month_descr];
			}

			for (var i = 0, ii = data.playlists.length; i < ii; i++){
				// Pegar data formatada do dia da playlist
				data.playlists[i].date = data.playlists[i].end_datetime_formatted.split(' ')[0].split('/')[0];

				// Verifica a data semanal das playlists. Ex: 10 a 16 de Maio de 2015
				if (data.playlists[i].day > 7){
					var date;
					if (data.playlists[i].nDay == 7){
						date = data.playlists[i].day - 6;
					}else{
						date = data.playlists[i].day - data.playlists[i].nDay;
					}
				}else{
					date = 0+1;
				}
				data.playlists[i].dividedDate = date;
			}
			$scope.playlists = data.playlists;
			finishLoad();
		})

	function verifyDateOnInit(){
		var octalMonth;
		if ($stateParams.year == date.getFullYear() && $stateParams.month > "0"+(date.getMonth()+1)){
			date.getMonth() > 10 ? octalMonth = date.getMonth() : octalMonth = "0"+(date.getMonth()+1);
			$state.go('menu.anterioresData', {year: date.getFullYear(), month: octalMonth})
			return false;
		}else if ($stateParams.year == 2011 && $stateParams.month < "04"){
			$state.go('menu.anterioresData', {year: "2011", month: "04"})
			return false;
		}else{
			return true;
		}
	}
	function verifyDate(){
		var fixMonths = function(initialMonth, lastMonth){
			var octalMonth;
			$scope.selectedMonth = "";
			$scope.months = [];
			for (var i = initialMonth; i < lastMonth; i++){
				i >= 10 ? octalMonth = i+1 : octalMonth = "0"+(i+1);
				$scope.months.push({key: octalMonth, value: stringMonth[i]})
			}
		}

		if ($scope.selectedYear == date.getFullYear() && $scope.selectedMonth > "0"+(date.getMonth()+1)){
			fixMonths(0,4);
			$scope.toast("Você tentou acessar um mês que ainda não chegou. Redirecionando para as playlists do mês atual.");
			return false;
		}else if ($scope.selectedYear == 2011 && $scope.selectedMonth < "04"){
			fixMonths(3,12);
			$scope.toast("O Playlisteiros começou no mês de Abril de 2011, não foram encontradas playlists no mês selecionado. Redirecionando para Abril de 2011.");
			return false;
		}
		return true;
	}
	$scope.changeYear = function(){
		if (!$scope.verifyConnection(true)){
			return false;
		}
		if (verifyDate()){
			$state.go('menu.anterioresData', {year: $scope.selectedYear, month: $scope.selectedMonth})
		}
	}
	$scope.changeMonth = function(){
		if (!$scope.verifyConnection(true)){
			return false;
		}
		if (verifyDate()){
			$state.go('menu.anterioresData', {year: $scope.selectedYear, month: $scope.selectedMonth})
		}
	}
}])

.controller('RankingController', [
	'$scope', '$rootScope', '$stateParams', '$ionicLoading', 'RankingModel',
	function($scope, $rootScope, $stateParams, $ionicLoading ,RankingModel){
	var startLoad = function() {
		$ionicLoading.show({template: '<div class=loader><i class="icon ion-load-c"></i></div>', noBackdrop: true});
	}
	,   finishLoad = function() {
		$ionicLoading.hide();
	}
	,   weekRanking = function(week, year, sessionID, sessionUser){
		if (!$scope.verifyConnection(true)){
			return false;
		}
		startLoad();
		RankingModel
			.getWeekRanking(week, year, $rootScope.userInfo.sessionID, $rootScope.userInfo.sessionUser, function(data){
				if (data.error){
					$scope.ranking.show = false;
				}else{
					var lvl2, L, l;
					for (var i = 0, ii = data.length; i < ii; i++){
						lvl2 = data[i].user_info.lvl - 1;
						L = lvl2-(lvl2%10);
						l = (lvl2%10);

						data[i].user_info.lvl1 = L;
						data[i].user_info.lvl2 = l;
					}
					$scope.ranking.show = data;
				}
				finishLoad();
			})
	}
	,   monthRanking = function(month, year, sessionID, sessionUser){
		if (!$scope.verifyConnection(true)){
			return false;
		}
		startLoad();
		RankingModel
			.getMonthRanking(month, year, $rootScope.userInfo.sessionID, $rootScope.userInfo.sessionUser, function(data){
				if (data.error){
					$scope.ranking.show = false;
				}else{
					var lvl2, L, l;
					for (var i = 0, ii = data.length; i < ii; i++){
						lvl2 = data[i].user_info.lvl - 1;
						L = lvl2-(lvl2%10);
						l = (lvl2%10);

						data[i].user_info.lvl1 = L;
						data[i].user_info.lvl2 = l;
					}
					$scope.ranking.show = data;
				}
				finishLoad();
			})
	}
	,   generalRanking = function(sessionID, sessionUser){
		if (!$scope.verifyConnection(true)){
			return false;
		}
		startLoad();
		RankingModel
			.getGeneralRanking($rootScope.userInfo.sessionID, $rootScope.userInfo.sessionUser, function(data){
				if (data.error){
					$scope.ranking.show = false;
				}else{
					var lvl2, L, l;
					for (var i = 0, ii = data.length; i < ii; i++){
						lvl2 = data[i].user_info.lvl - 1;
						L = lvl2-(lvl2%10);
						l = (lvl2%10);

						data[i].user_info.lvl1 = L;
						data[i].user_info.lvl2 = l;
					}
					$scope.ranking.show = data;
				}
				finishLoad();
			})
	}
	,   getWeekNumber = function(d){
			d = new Date(+d);
			d.setHours(0,0,0);
			d.setDate(d.getDate() + 4 - (d.getDay()||7));
			var yearStart = new Date(d.getFullYear(),0,1);
			var weekNo = Math.ceil(( ( (d - yearStart) / 86400000) + 1)/7)
			return [d.getFullYear(), weekNo];
	}
	,   weeksInYear = function (year) {
			var month = 11, day = 31, week, d;
			do{
				d = new Date(year, month, day--);
				week = getWeekNumber(d)[1];
			}while (week == 1);
			return week;
	}
	,   weekNow = function(year){
			var now, onejan, week;
			now = new Date();
			onejan = new Date(now.getFullYear(), 0, 1);
			week = Math.ceil( (((now - onejan) / 86400000) + onejan.getDay() + 1) / 7 );
			week = week -1;
			return week;
	}
	,   key
	,   forLoop
	,   currentTime = new Date()
	,   months = {
			1:'Janeiro',
			2:'Fevereiro',
			3:'Março',
			4:'Abril',
			5:'Maio',
			6:'Junho',
			7:'Julho',
			8:'Agosto',
			9:'Setembro',
			10:'Outubro',
			11:'Novembro',
			12 :'Dezembro'
		}
	,   selectedMonth = currentTime.getMonth()+1 < 10
		? "0" + (currentTime.getMonth()+1)
		: currentTime.getMonth()+1;

	$scope.$on('$ionicView.enter', function(){
		$scope.menu.title = "Ranking";
	})

	$scope.ranking = {};
	$scope.showSelect = "week"
	$scope.tab = "week";

	$scope.years = [];
	$scope.selectedYear = currentTime.getFullYear();
	$scope.months = [];
	$scope.selectedMonth = selectedMonth;
	$scope.weeks = [];
	$scope.selectedWeek = weekNow();

	// monta select da semana
	$scope.selectedYear == currentTime.getFullYear() ? forLoop = weekNow() : forLoop = weeksInYear($scope.selectedYear);
	for (var i = 1; i <= forLoop; i++){
		var week;
		i < 10 ? week = "0" + i : week = i;
		$scope.weeks.unshift({key: week, value: "Semana " + week});
	}
	// monta select do ano
	for (var i = 2011; i <= currentTime.getFullYear(); i++){
		$scope.years.unshift({key: i, value: i});
	}
	// monta select do mês
	if ($scope.selectedYear == currentTime.getFullYear()){
		var month;
		for (var i = 1; i <= currentTime.getMonth()+1; i++){
			i < 10 ? month = "0" + i : month = i;
			$scope.months.push({key: month, value: months[i]});
		}
	}else{
		var numberMonth = 1;
		for (key in months){
			key < 10 ? numberMonth = "0" + key : numberMonth = key;
			$scope.months.push({key: numberMonth, value: months[key]});
		}
	}

	$scope.changeTab = function(option){
		$scope.tab = option;

		if (!$scope.verifyConnection(true)){
			return false;
		}

		switch($scope.tab) {
			case "week":
				$scope.showSelect = 'week';
				mountWeeks();
				weekRanking($scope.selectedYear, $scope.selectedWeek, $rootScope.userInfo.sessionID, $rootScope.userInfo.sessionUser);
			break;
			case "month":
				$scope.showSelect = 'month';
				mountMonths();
				monthRanking($scope.selectedYear, $scope.selectedMonth, $rootScope.userInfo.sessionID, $rootScope.userInfo.sessionUser);
			break;
			case "general":
				$scope.showSelect = 'year';
				generalRanking($rootScope.userInfo.sessionID, $rootScope.userInfo.sessionUser);
			break;
		}
	}

	$scope.changeWeek = function(){
		weekRanking($scope.selectedYear, $scope.selectedWeek, $rootScope.userInfo.sessionID, $rootScope.userInfo.sessionUser);
	}
	$scope.changeMonth = function(){
		monthRanking($scope.selectedYear, $scope.selectedMonth, $rootScope.userInfo.sessionID, $rootScope.userInfo.sessionUser);
	}

	$scope.changeYear = function(){
		var currentTime = new Date;
		if ($scope.tab == 'week'){
			mountWeeks();
		}else if($scope.tab == 'month'){
			mountMonths();
		}
	}

	function mountWeeks(){
		// monta select da semana
		var week;
		$scope.weeks = [];
		$scope.selectedYear == currentTime.getFullYear() ? forLoop = weekNow() : forLoop = weeksInYear($scope.selectedYear);

		if ($scope.selectedYear == currentTime.getFullYear()){
			for (var i = 1; i <= weekNow(); i++){
				i < 10 ? week = "0" + i : week = i;
				$scope.weeks.unshift({key: week, value: "Semana " + week});
			}
		}else if ($scope.selectedYear == 2011){
			for (var i = 16; i <= 52; i++){
				i < 10 ? week = "0" + i : week = i;
				$scope.weeks.unshift({key: week, value: "Semana " + week});
			}
		}else{
			for (var i = 1; i <= forLoop; i++){
				i < 10 ? week = "0" + i : week = i;
				$scope.weeks.unshift({key: week, value: "Semana " + week});
			}
		}
		weekRanking($scope.selectedYear, $scope.selectedWeek, $rootScope.userInfo.sessionID, $rootScope.userInfo.sessionUser);
	}

	function mountMonths(){
		// monta select do mês
		var month;
		$scope.months = [];
		if ($scope.selectedYear == currentTime.getFullYear()){
			for (var i = 1, ii = currentTime.getMonth()+1; i <= ii; i++){
				i < 10 ? month = "0" + i : month = i;
				$scope.months.push({key: month, value: months[i]});
			}
		}else if ($scope.selectedYear == 2011){
			for (var i = currentTime.getMonth()+1; i <= 12; i++){
				i < 10 ? month = "0" + i : month = i;
				$scope.months.push({key: month, value: months[i]});
			}
			$scope.selectedMonth = "04";
		}else{
			var numberMonth = 1;
			for (key in months){
				key < 10 ? numberMonth = "0" + key : numberMonth = key;
				$scope.months.push({key: numberMonth, value: months[key]});
			}
		}
		monthRanking($scope.selectedYear, $scope.selectedMonth, $rootScope.userInfo.sessionID, $rootScope.userInfo.sessionUser);
	}
}])

.controller('FAQController',
	['$scope', '$stateParams', '$ionicScrollDelegate', '$ionicSlideBoxDelegate',
	function($scope, $stateParams, $ionicScrollDelegate, $ionicSlideBoxDelegate){

	$scope.$on('$ionicView.enter', function(){
		$scope.menu.title = "Regras";
	})

	var changeSection = function(action) {
		$scope.activeTab = action;
		switch(action) {
			case 'theGame':
				$ionicSlideBoxDelegate.slide(0);
				break;
			case 'points':
				$ionicSlideBoxDelegate.slide(1);
				break;
			case 'rules':
				$ionicSlideBoxDelegate.slide(2);
				break;
			case 'faq':
				$ionicSlideBoxDelegate.slide(3);
				break;
		}
	}
	$scope.slideIndex = 0;

	$scope.slideChanged = function(index) {
		$ionicScrollDelegate.scrollTop();
		$scope.slideIndex = index;
	};

	$scope.changeTab = changeSection;
	$scope.activeTab = 'theGame';
}])

.controller('ExtratoController', [
	'$scope', '$rootScope', '$stateParams', '$ionicLoading', 'ExtratoModel', '$ionicAnalytics',
	function($scope, $rootScope, $stateParams, $ionicLoading, ExtratoModel, $ionicAnalytics){
	$scope.extract = {};

	var startLoad = function() {
		$ionicLoading.show({template: '<div class=loader><i class="icon ion-load-c"></i></div>', noBackdrop: true});
	}
	,   finishLoad = function() {
		$ionicLoading.hide();
	}

	$scope.$on('$ionicView.enter', function(){
		$scope.verifyConnection(false);
		$scope.menu.title = "Extrato";
	})

	startLoad();
	ExtratoModel
		.userReport($stateParams.username, function(data){
			if (data.success){
				// Cor da barra de level
				var lvl2, L, l;
				lvl2 = data.success.user_info.lvl - 1;
				L = lvl2-(lvl2%10);
				l = (lvl2%10);

				data.success.user_info.lvl1 = L;
				data.success.user_info.lvl2 = l;

				if (data.success.user_info.bgUser){
					// Filtro e cor ainda não está sendo usados no Playlisteiros do www
					$scope.extract.bgUser = {
						bg : data.success.user_info.bgUser.bg,
						color : data.success.user_info.bgUser.color,
						filter : data.success.user_info.bgUser.filter
					}

					// Verifica qual tipo de background é, se não for color nem padrões Vagalume, é mosaico
					if ($scope.extract.bgUser.bg == "color"){
						// Evitar colocar conteúdo errado dentro de uma URL
						$scope.extract.bgUser.bg = null;
					}else if ($scope.extract.bgUser.bg.search("amazonaws") == -1){
						// Caso fundo não seja um mosaico, vem no objeto a URL com / direto, causando erro 404 pois não existe essa
						// imagem em m.vagalume.com.br. Ajustando link correto
						$scope.extract.bgUser.bg = "http://www.vagalume.com.br" + $scope.extract.bgUser.bg;
					}
				}

				// Pontuação das playlists
				$scope.extract.infos = data.success.user_info;
				$scope.extract.playlists = [];
				$scope.extract.types = {
					'suggest' : 'Música sugerida (Top 100)',
					'suggestDeleted' : 'Música removida',
					'suggestRanked1' : '1ª Música mais votada',
					'suggestRanked2' : '2ª Música mais votada',
					'suggestRanked3' : '3ª Música mais votada',
					'suggestRanked4' : '4ª Música mais votada',
					'suggestRanked5' : '5ª Música mais votada',
					'suggestRanked6' : '6ª Música mais votada',
					'suggestRanked7' : '7ª Música mais votada',
					'suggestRanked8' : '8ª Música mais votada',
					'suggestRanked9' : '9ª Música mais votada',
					'suggestRanked10' : '10ª Música mais votada',
					'suggestApproved' : 'Música aprovada',
					'block' : 'Bloqueado',
					'restart' : 'Pontuação zerada'
				}

				for (var key in data.success){
					if (data.success[key].vincs != undefined){
						$scope.extract.playlists.push(data.success[key]);
					}
				}
				finishLoad();
			}
		})

	ExtratoModel
		.userBadge($stateParams.username, function(data){
			if (data){
				$scope.extract.badges = data;
			}else{
				$scope.toast("Ocorreu um erro, tente novamente");
			}
		})

	$scope.vote = function(playlistID, vinculoID, key){
		if (!$scope.verifyConnection(true)){
			return false;
		}

		var obj = {
			playlistID     : playlistID,
			vinculoID      : vinculoID,
			voteType       : "positive",
			sessionID      : $rootScope.userInfo.sessionID,
			sessionUser    : $rootScope.userInfo.sessionUser,
			vinculoType    : "music"
		};

		ExtratoModel
			.computeVote(obj, function(data){
				if (data.success){
					$ionicAnalytics.track('Playlisteiros / Voto');
					$scope.extract.playlists[key].vincs[vinculoID].vote_balance++;
				}else{
					$scope.toast(data.error);
				}
			})
	}
	$scope.changeTab = function(option){
		$scope.tab = option;
	}

	$scope.closeExtract = function(){
		if (history.length === 1){
			window.location = baseUrl+"/";
		}else{
			history.back();
		}
	}
}])

.controller('LoginController',function($scope, sessionUser, $state, $ionicPopup, $cordovaToast, $ionicAnalytics, $ionicLoading, $timeout){
	var startLoad = function() {
		$ionicLoading.show({template: '<div class=loader><i class="icon ion-load-c"></i></div>', noBackdrop: false});
	}
	,   finishLoad = function() {
		$ionicLoading.hide();
	}
		
	function loginSuccess(data, status){
		if(data.success){
			$state.go('menu.playlist');
		} else {
			if(data.message){
				$ionicPopup.alert({'title':'Alerta','template':data.message});
			}
		}
	}
	$scope.funcSubmit = function(){
		$scope.loginMessage = '';
		// Verifica a conexão com a internet
		if (window.Connection) {
			if(navigator.connection.type == Connection.NONE) {
				$cordovaToast.showShortCenter('Verifique a conexão com a internet').then(function(success) {
				}, function (error) {
				});
			} else {
				sessionUser.login($scope.dataUser, $scope.dataPass, loginSuccess);
			}
		}
	}
	$scope.connectFacebook = function(){
		$scope.loginMessage = '';
		// Verifica a conexão com a internet
		if (window.Connection) {
			if(navigator.connection.type == Connection.NONE) {
				$cordovaToast.showShortBottom('Verifique a conexão com a internet').then(function(success) {
				}, function (error) {
				});
			} else {
				sessionUser.connect('facebook', loginSuccess);				
			}
		}
	}
	$scope.connectGoogle = function(){
		$scope.loginMessage = '';
		// Verifica a conexão com a internet
		if (window.Connection) {
			if(navigator.connection.type == Connection.NONE) {
				$cordovaToast.showShortBottom('Verifique a conexão com a internet').then(function(success) {
				}, function (error) {
				});
			} else {
				sessionUser.connect('google', loginSuccess);
			}
		}
	}
})

.controller('LostConnectionController',function($scope, $state){
	$scope.tryConnection = function() {
		if(window.Connection && navigator.connection.type != Connection.NONE) {
			$state.go('menu.playlist');
		}		
	}
})

.controller('RegisterController', function($scope, sessionUser, $state, $rootScope, $cordovaToast){
	if(window.Connection && navigator.connection.type == Connection.NONE) {
		$state.go('no-connection');
	}
	$scope.dataLabelGenre = 'Masculino';
	$scope.funcBack = function(){
		$state.go('login');
	}
	$scope.funcUpdateGenre = function(){
		$scope.dataLabelGenre = $scope.dataGenre ? 'Feminino' : 'Masculino';
	}
	$scope.funcRegister = function(){
		if(window.Connection && navigator.connection.type == Connection.NONE) {
			$cordovaToast.showShortCenter('Verifique a conexão com a internet').then(function(success) {
			}, function (error) {
			});
		}
		//'name':'gender':'email':'emailconf':'pass':'passconf':'agree':'nameshow':'login':'aboutMe':
		$scope.registerFullNameAlert = $scope.registerGenreAlert = $scope.registerEmailAlert = '';
		$scope.registerPassAlert = $scope.registerTermsAlert = $scope.registerShowNameAlert = '';
		$scope.registerLoginAlert = $scope.registerSubmitAlert = '';
		sessionUser.register(
			{
				name      :$scope.dataFullName,
				gender    :$scope.dataGenre ? 'female' : 'male',
				email     :$scope.dataEmail,
				emailconf :$scope.dataEmail,
				pass      :$scope.dataPass,
				passconf  :$scope.dataPass,
				agree     :$scope.dataTerms,
				nameshow  :$scope.dataShowName,
				login     :$scope.dataLogin,
				aboutMe   :''
			},
			function(success, error){
				if(success){
					$state.go('ok');
				} else {
					switch(error.field){
						case 'name':
							$scope.registerFullNameAlert = error.message;
							break;
						case 'gender':
							$scope.registerGenreAlert = error.message;
							break;
						case 'email':
							$scope.registerEmailAlert = error.message;
							break;
						case 'pass':
						case 'passconf':
							$scope.registerPassAlert = error.message;
							break;
						case 'agree':
							$scope.registerTermsAlert = error.message;
							break;
						case 'name_show':
						case 'nameshow':
							$scope.registerShowNameAlert = error.message;
							break;
						case 'login':
							$scope.registerLoginAlert = error.message;
							break;
						case 'timeout':
							break;
					}
					if(error.field){
						$scope.registerSubmitAlert = 'Alguma informação está incorreta, favor corrigir e tentar novamente';
					}
				}
				$scope.$digest(); // Atualiza a view sem a necessidade de interaè¤¯ do usuâ³©o
			}
		);
	}
})

.factory('MenuModel',
['$http',
function($http){
	var setPlaylistsMenu = function(cb){
		$http
			.get('http://app2.vagalume.com.br/ajax/playlisteiros.php?action=setPlaylistsMenu')
			.success(function(data) {
				if (data){
					cb(data);
				}else{
					cb(false);
				}
			})
			.error(function(e) {
				cb(false);
			})
	}
	,   searchPlaylist = function(playlist, cb){
		$http
			.get('http://suggest.vagalume.com.br/playlisteiros.json?q='+encodeURIComponent(playlist)+'&limit=10')
			.success(function(data) {
				if (data){
					cb(data);
				}else{
					cb(false);
				}
			})
			.error(function(e) {
				cb(false);
			})
	}
	,   logoff = function(sessionID, sessionUser, cb){
		$http
			.get('http://auth.vagalume.com.br/login/json.php?action=logoff&sessionID='+sessionID+'&sessionUser='+sessionUser)
			.success(function(data) {
				if (data){
					cb(data);
				}else{
					cb(false);
				}
			})
			.error(function(e) {
				cb(false);
			})
	}

	return {
		setPlaylistsMenu : setPlaylistsMenu,
		searchPlaylist : searchPlaylist,
		logoff : logoff
	}
}])

.factory('LoginModel', ['$http', function($http){
	var getUserlevel = function(sessionID, sessionUser, cb){
		$http
			.get('http://app2.vagalume.com.br/ajax/playlisteiros.php?action=getUserlevel&sessionID='+sessionID+'&sessionUser='+sessionUser)
			.success(function(data) {
				cb(data||false);
			})
			.error(function(e) {
				cb(false);
			})
	}

	return {
		getUserlevel : getUserlevel
	}
}])

.factory('PlaylistModel',
['$http',
function($http){
	var getInfoPlaylist = function(playlistName, cb){
		$http
			.get('http://app2.vagalume.com.br/ajax/playlisteiros.php?action=getPlaylist&page='+playlistName)
			.success(function(data){
				cb(data||false);
			})
			.error(function(e) {
				cb(false);
			})
	}
	,   getSuggestedPlaylists = function(option, sessionID, sessionUser, cb){
		$http
			.get('http://app2.vagalume.com.br/ajax/playlisteiros.php?action=getPlaylists&orderby='+option+'&sessionID='+sessionID+'&sessionUser='+sessionUser)
			.success(function(data){
				cb(data||false);
			})
			.error(function(e) {
				cb(false);
			})
	}
	,   computeVote = function(playlistID, vinculoID, voteType, sessionID, sessionUser, vinculoType, cb){
		$http
			.get('http://app2.vagalume.com.br/ajax/playlisteiros.php?action=computeVote&playlistID='+playlistID+'&vinculoID='+vinculoID+'&voteType='+voteType+'&sessionID='+sessionID+'&sessionUser='+sessionUser+'&vinculoType='+vinculoType)
			.success(function(data){
				cb(data||false);
			})
			.error(function(e) {
				cb(false);
			})
	}
	,   addPlaylist = function(playlistName, rule, sessionID, sessionUser, cb){
		$http
			.get('http://app2.vagalume.com.br/ajax/playlisteiros.php?action=addPlaylist&tema_descr='+encodeURIComponent(playlistName)+'&sessionID='+sessionID+'&sessionUser='+sessionUser+'&descrLong='+encodeURIComponent(rule))
			.success(function(data){
				cb(data||false);
			})

			.error(function(e) {
				cb(false);
			})
	}
	,   anteriores = function(year, month, cb){
		var link = 'http://app2.vagalume.com.br/ajax/playlisteiros.php?action=previous';
		if (year != null){
			link += '&page='+year+'&param='+month;
		}else{
			link += '&page=anteriores';
		}

		$http
			.get(link)
			.success(function(data){
				cb(data||false);
			})
			.error(function(e){
				cb(false);
			})
	}
	,   getMusics = function(playlistID, order, sessionID, sessionUser, cb){
		$http
			.get('http://app2.vagalume.com.br/ajax/playlisteiros.php?action=getMusic&playlistID='+playlistID+'&orderby='+order+'&sessionID='+sessionID+'&sessionUser='+sessionUser)
			.success(function(data){
				cb(data||false);
			})
			.error(function(e) {
				cb(false);
			})
	}
	,   getComments = function(playlistID, lastCommentID, type, moreComments, cb){
		var arg;

		moreComments == true ? arg = "&limitComments=15" : arg = "";
		$http
			.get('http://app2.vagalume.com.br/ajax/playlisteiros.php?action=getComments&playlistID='+playlistID+'&lastCommentID='+lastCommentID+'&type='+type+arg)
			.success(function(data){
				cb(data||false);
			})
			.error(function(e) {
				cb(false);
			})
	}
	,   addComment = function(comment, playlistID, lastCommentID, sessionID, sessionUser, cb){
		$http
			.get('http://app2.vagalume.com.br/ajax/playlisteiros.php?action=addComment&comment='+encodeURIComponent(comment)+'&playlistID='+playlistID+'&lastCommentID='+lastCommentID+'&sessionID='+sessionID+'&sessionUser='+sessionUser)
			.success(function(data){
				cb(data||false);
			})
			.error(function(e){
				cb(false);
			})
	}
	,   respComment = function(comment, commentID, commentFirst, playlistID, sessionID, sessionUser, loginUser, cb){
		$http
			.get('http://app2.vagalume.com.br/ajax/playlisteiros.php?action=responseComment&responseComment='+encodeURIComponent(comment)+'&commentID='+commentID+'&commentFirst='+commentFirst+'&playlistID='+playlistID+'&sessionID='+sessionID+'&sessionUser='+sessionUser+'&loginUser='+loginUser+'&v2=1')
			.success(function(data){
				cb(data||false);
			})
			.error(function(e){
				cb(false);
			})
	}
	,   removeComment = function(playlistID, commentID, sessionID, sessionUser, cb){
		$http
			.get('http://app2.vagalume.com.br/ajax/playlisteiros.php?action=removeComment&playlistID='+playlistID+'&commentID='+commentID+'&sessionID='+sessionID+'&sessionUser='+sessionUser)
			.success(function(data){
				cb(data||false);
			})
			.error(function(e){
				cb(false);
			})
	}
	,   denunciateUser = function(commentID, playlistID, loginUser, delation, sessionID, sessionUser, cb){
		$http
			.get('http://app2.vagalume.com.br/ajax/playlisteiros.php?action=denunciateUser&blamedDataType=comments&blamedDataID='+commentID+'&playlistID='+playlistID+'&loginUser='+loginUser+'&delation='+encodeURIComponent(delation)+'&sessionID='+sessionID+'&sessionUser='+sessionUser)
			.success(function(data){
				cb(data||false);
			})
			.error(function(e){
				cb(false);
			})
	}
	,   denunciateMusic = function(musicID, playlistID, loginUser, delation, sessionID, sessionUser, cb){
		$http
			.get('http://app2.vagalume.com.br/ajax/playlisteiros.php?action=denunciateUser&blamedDataType=vinculos&blamedDataID='+musicID+'&playlistID='+playlistID+'&loginUser='+loginUser+'&delation='+encodeURIComponent(delation)+'&sessionID='+sessionID+'&sessionUser='+sessionUser)
			.success(function(data){
				cb(data||false);
			})
			.error(function(e){
				cb(false);
			})
	}
	,   suggest = function(search, cb){
		$http
			.get('http://suggest.vagalume.com.br/mus.json?limit=15&showscore=1&q='+encodeURIComponent(search))
			.success(function(data){
				cb(data||false);
			})
			.error(function(e){
				cb(false);
			})
	}
	,   buildToken = function(playlistID, sessionID, sessionUser, cb){
		$http
			.get('http://app2.vagalume.com.br/ajax/playlisteiros.php?action=buildToken&playlistID='+playlistID+'&sessionID='+sessionID+'&sessionUser='+sessionUser)
			.success(function(data){
				cb(data||false);
			})
			.error(function(e) {
				cb(false);
			})
	}
	,   addMusicToPlaylist = function(playlistID, musicID, token, sessionID, sessionUser, cb){
		$http
			.get('http://app2.vagalume.com.br/ajax/playlisteiros.php?action=addMusicToPlaylist&playlistID='+playlistID+'&pointerHID='+musicID+'&token='+token+'&sessionID='+sessionID+'&sessionUser='+sessionUser)
			.success(function(data){
				cb(data||false);
			})
			.error(function(e){
				cb(false);
			})
	}
	,   getPlaylistUrl = function(type, cb){
		// type = yesterday, today, tomorrow
		$http
			.get('http://app2.vagalume.com.br/ajax/playlisteiros.php?action=getPlaylistUrl&type='+type)
			.success(function(data){
				cb(data||false);
			})
			.error(function(e){
				cb(false);
			})
	}

	return {
		getInfoPlaylist : getInfoPlaylist,
		getSuggestedPlaylists : getSuggestedPlaylists,
		computeVote : computeVote,
		addPlaylist : addPlaylist,
		anteriores : anteriores,
		getComments : getComments,
		getMusics : getMusics,
		addComment : addComment,
		respComment : respComment,
		removeComment : removeComment,
		denunciateUser : denunciateUser,
		denunciateMusic : denunciateMusic,
		suggest : suggest,
		buildToken : buildToken,
		addMusicToPlaylist : addMusicToPlaylist,
		getPlaylistUrl : getPlaylistUrl
	}
}])

.factory('PlaylisteirosPlayer',
	['$rootScope','$timeout', '$ionicLoading',
	function($rootScope, $timeout, $ionicLoading){
	var mvplayer = {};

	var playerObj
	,   isPlaylist
	,   hasCORS = ('withCredentials' in new XMLHttpRequest())
	,   fromYoutube = false
	,   playerTime = {
		instance : null,
		time : 0
	}
	,   startLoad = function() {
		$ionicLoading.show({template: '<div class=loader><i class="icon ion-load-c"></i></div>', noBackdrop: true});
	}
	,   finishLoad = function() {
		$ionicLoading.hide();
	}

	function _setupPlayer(elem, params) {
		if (!elem || !params) return;
			vPlayer.init(elem, {
				autoPlay: true,
				currentSong:params.currentSong || false,
				repeat:false,
				dimensions:'default',
				category:false,
				controls: 0,
				isPlaylisteiros: true
			});
	}

	function initPlayer(params){
		var playerDIV = document.getElementById('playerArea2');
		params = params || {};
		isPlaylist = !params.source;

		if(isPlaylist) {
			var song = document.querySelector('.playlist li')
			,   info = _getSongInfo();
			_getSongID(info, function(conf){
				var param = {
					currentSong: conf
				}
				fromYoutube = true;
				_setupPlayer(playerDIV ? playerDIV : params.target, param);
			})
		}else{
			// TODO: VERIFICAR ISSO!
			var ytID = params.source
			,   service = params.service;

			var param = {
				currentSong: {
					source  : ytID,
					service : service,
					band    : params.band || false,
					bandID  : params.bandID || false,
					title   : params.title || false,
					bandSlug: params.band_img || false
				}
			};
			fromYoutube = true;
			_setupPlayer(playerDIV ? playerDIV : params.target, param);
		}

		// Player está pronto
		playerDIV.addEventListener('player.ready', function(){
			playerObj = playerDIV.vPlayer;
			$rootScope.$emit('player.ready', playerObj);
			$rootScope.vPlayer.time = {};
		})
		playerDIV.addEventListener('player.play', function(){
			angular.element(document.querySelectorAll('.playPause')).removeClass('ion-play').addClass('ion-pause');
			getDuration();
			progressTime();
		})
		playerDIV.addEventListener('player.ended', function(){
			// Se loop estiver ativado e for a ultima música, o playlistWalk vai fazer repetir a playlist
			if (loop() && $rootScope.vPlayer.currentSong == vPlayerlist.length-1){
				playlistWalk();
			}
		})
		playerDIV.addEventListener('player.canplay', function(){
			$rootScope.finishLoad = true;
			playerObj.play();
			resetCurrentTime();
		})
		playerDIV.addEventListener('player.pause', function(){
			$timeout.cancel(playerTime.instance);
			angular.element(document.querySelectorAll('.playPause')).removeClass('ion-pause').addClass('ion-play');
		})
		playerDIV.addEventListener('player.buffering', function(){})
		playerDIV.addEventListener('player.error', function(){})
		playerDIV.addEventListener('player.next', function(){
			playlistWalk();
		})
		playerDIV.addEventListener('player.before', function(){
			playlistWalk(true);
		})
	}

	function playAndPauseSong(){
		var playerBtn = angular.element(document.querySelectorAll(".playPause"));
		if (playerBtn.hasClass('ion-play')){
			playerObj.play();
			angular.element(playerBtn).removeClass('ion-play').addClass('ion-pause');
		}else{
			playerObj.pause();
			angular.element(playerBtn).removeClass('ion-pause').addClass('ion-play');
		}
	}

	function getDuration(){
		playerObj.instances.mediaYoutube.getDuration(function(duration){
			var totalSeconds = duration
			,   minutes = Math.floor(totalSeconds / 60)
			,   seconds = duration - minutes * 60;

			seconds = Math.floor(seconds);

			if (seconds < 10){
				seconds = "0" + seconds;
			}

			$rootScope.vPlayer.time.realDuration = duration;
			$rootScope.vPlayer.time.duration = minutes + ":" + seconds;
		})
	}

	function getPlayerInstance(){
		return playerObj;
	}

	function progressTime(){
		function count(){
			playerObj.instances.mediaYoutube.getCurrentTime(function(currentTime){
				if (currentTime){
					$rootScope.vPlayer.time.now = currentTime;
					getProgress($rootScope.vPlayer.time.now, $rootScope.vPlayer.time.realDuration);
					playerTime.instance = $timeout(function(){count()}, 1000);
					$rootScope.vPlayer.time.now = getTrueTime($rootScope.vPlayer.time.now)['minutes'] + ":" +  getTrueTime($rootScope.vPlayer.time.now)['seconds'];
				}

				if ($rootScope.vPlayer.time.now > $rootScope.vPlayer.time.duration){
					$timeout.cancel(playerTime.instance);
				}
			});
		}

		function getTrueTime(time){
			var totalSeconds = Math.floor(time)
			,   minutes = Math.floor(totalSeconds / 60)
			,   seconds = totalSeconds - minutes * 60;

			if (time == 0){
				$rootScope.vPlayer.time.now = "0:00";
			}

			if (seconds < 10){
				seconds = "0" + seconds;
			}
			return {minutes: minutes, seconds: seconds}
		}

		function getProgress(timeNow, timeTotal){
			var total =  timeNow / timeTotal * 100;
			$rootScope.vPlayer.time.progress = total + '%';
		}

		if (playerObj){
			playerTime.instance = $timeout(function(){count()}, 1000);
		}
	}

	// Impedir que continue o tempo atual da música
	function resetCurrentTime(){
		$rootScope.vPlayer.time.now = "0:00";
		$rootScope.vPlayer.time.progress = 0;
		$timeout.cancel(playerTime.instance);
		playerTime = {
			instance : null,
			time : 0
		}
	}

	function playSelectedMusic(conf){
		_getSongID(conf, _startSong);
	}

	function _startSong(conf){
		playerObj.loadAndPlay(conf);
	}

	function destroyPlayer(){
		if(playerObj){
			playerObj.pause();
			$rootScope.vPlayer = {
				controlShow : false,
				currentSong : 0,
				info : null,
				loop : false,
				playerShow : false,
				playlist : null,
				showPlaylist : false,
				shuffle : false,
				time : {}
			}
		}
	}

	function setPlayerBackground(string){
		if (string != null && string != "profilew45"){
			var pic = string.replace("profile","profile-bigw350");
			return pic;
		}
	}

	function shuffle(){
		if ($rootScope.vPlayer.shuffle){
			return true;
		}else{
			return false;
		}
	}

	function loop(){
		if ($rootScope.vPlayer.loop){
			return true;
		}else{
			return false;
		}
	}

	function rewind(){
		playlistWalk(true);
	}

	function forward(){
		playlistWalk();
	}

	function seekProgressBar(percent){
		var duration = $rootScope.vPlayer.time.realDuration
		,   time = duration * percent / 100;

		playerObj.instances.mediaYoutube.stop();
		playerObj.youtube.setProgressbar(Math.floor(time));
		playerObj.instances.mediaYoutube.play();
	}

	function updateProgressBar(value){
		$rootScope.vPlayer.time.progress = value;
	}

	function playlistWalk(rewind){
		var player = $rootScope.vPlayer
		,   playlist = vPlayerlist
		,   lastMusic = vPlayerlist.length-1;

		if (player.currentSong == 0 && rewind){
			player.currentSong = lastMusic;
		}else if (player.currentSong == lastMusic && !rewind){
			player.currentSong = 0;
		}else{
			rewind == true ? player.currentSong-- : player.currentSong++;
		}

		player.info = {
			music: playlist[player.currentSong].pointer_name,
			artist: playlist[player.currentSong].band_descr,
			bandImg : playlist[player.currentSong].band_img
		}
		$rootScope.vPlayer.controlImage = playlist[player.currentSong].band_img;

		var playPause = document.querySelector('.playPause');
		if (document.querySelector('.playPause.ion-pause')){
			playPause.setAttribute("class", "playPause icon ion-play");
		}

		resetCurrentTime();
		// Pegar as informações da próxima música e dá play
		_getSongInfo();
		_getSongID(player.info, _startSong);
	}

	function setArtistSmallPic(string){
		if (string != null && string != "profilew45"){
			var pic = string.replace("profile","profilew45");
			return pic;
		}
	}

	function _getSongInfo(){
		var songInfo = {
			music: $rootScope.vPlayer.info.music,
			artist: $rootScope.vPlayer.info.artist,
			bandImg: $rootScope.vPlayer.controlImage
		};
		return songInfo;
	}

	function _getSongID(info,callback){
		$rootScope.finishLoad = false;
		var query = (info.artist+' '+info.music).replace(/"/g,' ').replace(/\s+/g,' ').replace(/^\s|\s$/g,'').toLowerCase()
		,   url = 'https://proxy.vagalume.com.br/api/youtube-v3/search?'+([
			'maxResults=50',
			'orderby=relevance',
			'part=snippet',
			'q='+encodeURIComponent(query),
			'type=video'
		]).join('&');

		$rootScope.vPlayer.background = setPlayerBackground($rootScope.vPlayer.info.bandImg);

		httpRequestAPI(url,function(ytJSON){
			var sourceIDs = ''
			,   ytList = JSON.parse(ytJSON)
			,   items = ytList.items
			,   itemsLength = items.length;

			// Pegaremos apenas os 3 primeiros vídeos para tentar toca-los.
			for (var x = 0; x <= 2; x++) {
				sourceIDs += items[x].id.videoId + ',';
			};

			var conf = {
				source: sourceIDs.substring(0, sourceIDs.length - 1),
				service: 'youtube',
				band: info.artist,
				title: info.music,
				bandImg: info.bandImg
			}
			var yt = document.querySelector('#iframeYoutube');
			if (yt) {
				document.querySelector('#iframeYoutube').setAttribute('src', 'http://api.vagalume.com.br/playerYoutubeAngular.html?id='+conf.source.split(',')[0]+'&auto=1&w=100%&h=100%');
			} else {
				window.VideoID = conf.source.split(',')[0];
			}
			callback && callback(conf);
		});
	}

	// AJAX API
	function httpRequestAPI(url,callback){
		var xmlhttp = new XMLHttpRequest();
		xmlhttp.onreadystatechange=function(){
			if (xmlhttp.readyState==4 && xmlhttp.status==200){
				if(callback) callback(xmlhttp.responseText);
			}
		}
		xmlhttp.open('GET',url,true);
		xmlhttp.setRequestHeader("Referer", "http://www.vagalume.com.br/playlisteiros/");
		xmlhttp.send();
	}

	mvplayer.initPlayer = initPlayer;
	mvplayer.playAndPauseSong = playAndPauseSong;
	mvplayer.rewind = rewind;
	mvplayer.forward = forward;
	mvplayer.destroyPlayer = destroyPlayer;
	mvplayer.playSelectedMusic = playSelectedMusic
	mvplayer.seekProgressBar = seekProgressBar
	mvplayer.getPlayerInstance = getPlayerInstance

	return mvplayer;
}])

.factory('RankingModel', ['$http', function($http){
	var getGeneralRanking = function(sessionID, sessionUser, cb){
		$http
			.get('http://app2.vagalume.com.br/ajax/playlisteiros_score.php?action=alltime&type=total&limit=20&sessionUser='+sessionUser+'&sessionID='+sessionID)
			.success(function(data) {
				cb(data||false);
			})
			.error(function(e) {
				cb(false);
			})
	}
	,   getMonthRanking = function(year, month, sessionID, sessionUser, cb){
		$http
			.get('http://app2.vagalume.com.br/ajax/playlisteiros_score.php?action=month&type=total&limit=10&sessionUser='+sessionID+'&sessionID='+sessionUser+'&status=true&yearmonth='+year+month)
			.success(function(data) {
				cb(data||false);
			})
			.error(function(e) {
				cb(false);
			})
	}
	,   getWeekRanking = function(year, week, sessionID, sessionUser, cb){
		$http
			.get('http://app2.vagalume.com.br/ajax/playlisteiros_score.php?action=week&type=total&limit=20&sessionUser='+sessionUser+'&sessionID='+sessionID+'&status=true&yearweek='+year+week)
			.success(function(data) {
				cb(data||false);
			})
			.error(function(e) {
				cb(false);
			})
	}

	return {
		getGeneralRanking : getGeneralRanking,
		getMonthRanking : getMonthRanking,
		getWeekRanking : getWeekRanking
	}
}])

.factory('ExtratoModel', ['$http', '$rootScope', function($http, $rootScope){
	var userReport = function(username, cb){
		$http
			.get('http://app2.vagalume.com.br/ajax/playlisteiros_score.php?action=userReport&serial=20120327&userLogin='+username+'&userSessionID='+$rootScope.userInfo.sessionID)
			.success(function(data){
				if (data){
					cb(data);
				}else{
					cb(false);
				}
			})
			.error(function(e) {
				cb(false);
			})
	}
	,   computeVote = function(obj, cb){
		$http
			.get('http://app2.vagalume.com.br/ajax/playlisteiros.php?action=computeVote&playlistID='+obj.playlistID+'&vinculoID='+obj.vinculoID+'&voteType='+obj.voteType+'&sessionID='+obj.sessionID+'&sessionUser='+obj.sessionUser+'&vinculoType='+obj.vinculoType)
			.success(function(data) {
				if (data){
					cb(data);
				}else{
					cb(false);
				}
			})
			.error(function(e) {
				cb(false);
			})
	}
	,   userBadge = function(login, cb){
		$http
			.get('http://app2.vagalume.com.br/ajax/playlisteiros_score.php?action=userBadge&login='+login)
			.success(function(data) {
				if (data){
					cb(data);
				}else{
					cb(false);
				}
			})
			.error(function(e) {
				cb(false);
			})
	}

	return {
		userReport: userReport,
		computeVote: computeVote,
		userBadge : userBadge
	}
}])

.factory('sessionUser',
	['$http', '$q', '$state', '$rootScope', '$cordovaSQLite', '$cordovaToast',
	function($http, $q, $state, $rootScope, $cordovaSQLite, $cordovaToast){
		var loginURL = 'https://auth.vagalume.com.br/'
		  , user = {}
		  , edit = {}
		  , whenLoggedListeners = []
		  , helloIninted = false;

		function connect(service, cb, redirect){
			var accessToken = false
			,   userLogin = false;
			if (service == "google") {
				window.plugins.googleplus.isAvailable(function (available) {
					if (available) {
						window.plugins.googleplus.login(
							{'iOSApiKey': '363858085852-6cjj41r95kv3tukkiv6v4k3d4r5sumbh.apps.googleusercontent.com'},
							function (obj) {
								try {
									accessToken = obj.oauthToken;
								} catch(e) {
									errorHandler(e);
									return;
								}
								initLogin();
							},
							function (msg) {
								cb(normalizeLoginMessage('NO_MSG'));
							}
						);						
					} else {
						$cordovaToast.showLongCenter('Não foi possível conectar ao Google+');
					}
				});
			} else {
				var resAccessToken = function(token) {					
					try {
						accessToken = token;
					} catch(e) {
						errorHandler(e);
						return;
					}
					initLogin();
				}

				facebookConnectPlugin.getAccessToken(function(result){
					resAccessToken(result)
				},function(){
					facebookConnectPlugin.login(["email"], function(response) {
						if (response.authResponse) {
							facebookConnectPlugin.getAccessToken(function(result){
								resAccessToken(result)
							})
						}
					},function(response){
						cb(normalizeLoginMessage('NO_MSG'));
					});
				})
			}

			function initLogin(){
				var params = '?access_token=' + encodeURI(accessToken)
				+ '&vgl_action=login'
				+ '&vgl_from=' + encodeURI(service)
				+ '&callback=JSON_CALLBACK';
				$http.jsonp(loginURL+'external_login.php'+params).success(function(data){
					if (data && data.sessionID) {
						data.session = {
							ID: data.sessionID,
							User: data.sessionUser
						}
					}
					data = normalizeLoginMessage(data);
					if(data && data.session){
						saveSessionSQLite(data);
						instance.on && instance.on('logged');
					}
					switch(data.code){
						case 'FAIL_LOGIN':
							data.error = 'CANNOT_CONNECT';
							break;
						case 'INVALID_LOGIN':
					}
					cb(data || null);
				});
			}
		}

		function checkUserLogged(){
			var query = 'SELECT sessionID, sessionUser FROM info';
			$cordovaSQLite
				.execute(db, query)
				.then(function(res){
					if(res.rows.length) {
					   $rootScope.userInfo = {
							'sessionID'   : res.rows.item(0).sessionID,
							'sessionUser' : res.rows.item(0).sessionUser,
						}
						$rootScope.$emit('userLogged');
						$rootScope.user.isLogged = true;
					} else {
						$rootScope.user.isLogged = false;
					}
				})
		}

		function removeSessionSQLite() {
			var query = "DELETE FROM info";
			$cordovaSQLite.execute(db, query);
			checkUserLogged();
		}

		function saveSessionSQLite(data) {
			if (!data || (data && !data.session)) return false;
			removeSessionSQLite();
			var query = "INSERT INTO info (sessionID, sessionUser) VALUES (?,?)";
			$cordovaSQLite.execute(db, query, [data.session.ID, data.session.User]);
			checkUserLogged();
		}

		function fieldErrorMessage(field){
			switch(field){
				case 'name': return 'Nome inválido';
				case 'gender': return 'Gênero inválido';
				case 'email': return 'E-mail inválido';
				case 'emailconf': return 'E-mail inválido';
				case 'pass': return 'Senha inválida';
				case 'passconf': return 'Senha inválido';
				case 'agree': return 'Necessário concordar com termos de uso e privacidade';
				case 'name_show':
				case 'nameshow': return 'Nome inválido';
				case 'login': return 'Login inválido';
				case 'aboutMe': return 'Texto inválido';
				case 'timeout': return 'Erro ao registrar';
			}
			return '';
		}

		function getFieldDataError(field, data){
			var val = data[field];
			switch(field){
				case 'name':
					if(!val) return 'Nome requerido';
				case 'nameshow':
				case 'name_show':
					break;
				case 'login':
					if(!val) return 'Login requerido';
					break;
				case 'emailconf':
					if(val !== data.email) return 'E-mail não confere';
				case 'email':
					if(!val) return 'E-mail requerido';
					break;
				case 'passconf':
				case 'pass':
					if(!val) return 'Senha requerida';
					break;
				case 'agree':
					if(!val) return 'Necessário concordar com os termos de uso';
					break;
				case 'telefone1':
				case 'telefone2':
				case 'telefone3':
					break;
				case 'address':
				case 'bairro':
				case 'cep1':
				case 'cep2':
				case 'cep':
				case 'city':
				case 'state':
				case 'gender':
				case 'countryID':
				case 'noFindMe':
			}
			return null;
		}

		function getDataErrors(data){
			var hasError = false
			  , errors   = {};
			for(var field in data){
				var error = getFieldDataError(field, data);
				if(error) {
					errors[field] = error;
					hasError = true;
				}
			}
			return hasError ? errors : null;
		}

		function getSessionID(){
			return ($rootScope && $rootScope.userInfo && $rootScope.userInfo.sessionID) || false;
		}

		function getSessionUserID(){
			return ($rootScope && $rootScope.userInfo && $rootScope.userInfo.sessionUser) || false;
		}

		function getSessionUserData(callback){
			if(getSessionUserID()){
				requestAction('getSessionUser', null, callback);
			} else {
				setTimeout(function(){
					callback(false);
				}, 1);
			}
		}

		function load(callback){
			getSessionUserData(function(userData){
				if(userData){
					for(var name in userData){
						switch(name){
							case 'nasc':
								edit.nasc = user.nasc = userData.nasc.split('-').reverse().join('/');
								break;
							case 'gender':
								edit[name] = (userData.gender == 'female');
								break;
							case 'countryID':
								user.isBR = userData[name] == 'BR';
								edit[name] = user[name] = userData[name];
								break;
							case 'state':
								edit[name] = user[name] = userData[name];
								break;
							case 'name':
							case 'name_show':
							case 'email':
							case 'address':
							case 'bairro':
							case 'cep':
							case 'city':
							case 'login':
							case 'aboutme':
								edit[name] = user[name] = userData[name];
								break;
							case 'preferences':
								edit.newsletter = user.newsletter = Boolean(userData.preferences.match(/newsletter/));
								break;
							case 'noFindMe':
								edit.noFindMe = user.noFindMe = !userData.noFindMe;
								break;
							case 'publicSocialNetworks':
								edit.publicSocialNetworks = user.publicSocialNetworks = userData.publicSocialNetworks;
								break;
							case 'pass':
						}
					}
					for(var i=1, tel; i<=3; i++){
						tel = userData['ddd' + i];
						tel = tel ? ('('+tel+') ') : '';
						tel = tel + userData['telefone'+i];
						edit['telefone' + i] = user['telefone' + i] = tel;
						edit['gender'] = user['gender'] = userData['gender'];
						edit['user_photo'] = user['user_photo'] = userData['user_photo'];
					}
				}
				callback && callback(user);
			});
			return user;
		}

		function login(user, pass, cb){
			var url = loginURL+'login/json.php?action=logon'
				+ '&login='+user+'&pass='+pass
				+ '&getSession=1'
				+ '&callback=JSON_CALLBACK';
			return $http.jsonp(url)
				.success(function(data){
					data = normalizeLoginMessage(data);
					if(data && data.session){
						saveSessionSQLite(data);
						instance.on && instance.on('logged');
					}
					switch(data.code){
						case 'FAIL_LOGIN':
							data.error = 'CANNOT_CONNECT';
							break;
						case 'INVALID_LOGIN':
					}
					cb(data || null);
				})
				.error(function(){
					cb(false);
				});
		}

		function logoff(callback){
			removeSessionSQLite();
			return requestAction('logoff', null, callback);
		}

		function normalizeLoginMessage(data){
			var success = Boolean(data && (data.success || data.session))
			  , errorCode = (data ? (data.error || data.code) : 'FAIL_LOGIN')
			  , session = (data && data.session) || null
			  , messageMap = {
				'BANNED'            :'Usuário banido',
				'CANNOT_CREATE_USER':'Não foi possível criar uma conta',
				'CANNOT_CONNECT'    :'Não foi possível conectar',
				'DELETED'           :'Usuário excluido',
				'FAIL_LOGIN'        :'Login e/ou senha incorreto',
				'INVALID_LOGIN'     :'Login inválido',
				'INVALID_PASS'      :'Senha inválido',
				'LOGGED'            :'Logado com sucesso',
				'NO_SERVICE'        :'Serviço requerido',
				'NO_USER_DATA'      :'Login e/ou senha incorreto',
				'TRUSTED_LOGGED'    :'Logado com sucesso',
				'VINC_IS_ALREADY'   :'Usuário já existe'
			    };
			switch(errorCode){
				case 'TRUSTED_LOGGED':
				case 'LOGGED':
					success = true;
					break;
				default:
					if(success) {
						for(var i=0, s=whenLoggedListeners.length; i<s; i++){
							whenLoggedListeners[i](user);
						}
						whenLoggedListeners = [];
						$rootScope.$emit('user.logged');
						errorCode = 'LOGGED'
					};
			}
			return {
				success:success,
				code:errorCode,
				session:session || null,
				message:messageMap[errorCode]
			};
		}

		function onFail(field, callback){
			callback(false, {field:field,message:fieldErrorMessage(field)});
		}

		function requestAction(action, params, callback, useSession){
			params = params || {};
			params.action = action;
			if(useSession !== false){
				params.sessionID = getSessionID();
				params.sessionUser = getSessionUserID();
			}
			params.callback = 'JSON_CALLBACK';
			var url = loginURL+'login/json.php'
			  , p = '';
			for(var k in params){
				p += (p ? '&' : '?') + k + '=' + encodeURI(params[k]);
			}
			$http.jsonp(url+p)
				.success(function(response){
					callback(response);
				})
				.error(function(){
					callback(false);
				});
			return instance;
		}

		function register(data, callback){
			var errors   = getDataErrors(data)
			, url        = loginURL+'login/add.php?action=addUser'
			, validParam = true
			, val        = null
			if(errors){
				setTimeout(function(){
					onFail(errors, callback);
				}, 1);
			} else {
				$http.post(url, data)
				.success(function(response){
					if(!response || response.error){
						onFail(response.error, callback);
					} else {
						if (response.sessionID) {
							response.session = {
								ID: response.sessionID,
								User: response.sessionUser
							}
						}
						saveSessionSQLite(response);
						callback(true);
					}
				})
				.error(function(){
					onFail('timeout', callback);
				});
			}
		}

		function whenLogged(callback){
			if(user){
				callback(user);
			} else {
				whenLoggedListeners.push(callback);
			}
			return user;
		}

		var instance = {
			action:requestAction,
			connect:connect,
			getSessionID:getSessionID,
			getSessionUserID:getSessionUserID,
			load:load,
			login:login,
			logoff:logoff,
			register:register,
			user:user,
			whenLogged:whenLogged,
			checkUserLogged:checkUserLogged
		};
		return instance;
	}]
)

/*
* mobile-vplayer.js
*/

window.vPlayer = {};
(function(vPlayer){
	vPlayer.domain = 'http://www.vagalume.com.br';

	// Carregar CSS
	var loadCSS = function(href) {
		var cssLink = $("<link rel='stylesheet' type='text/css' href='"+href+"'>");
		document.getElementsByTagName('head').innerHTML = cssLink;
	};

	// Função para verificar se o browser suporta
	var isSupportedBrowsers = function() {
		if (typeof(Worker) != "undefined") return true;
		return false;
	}
	
	vPlayer.init = function (elem, conf) {
		// Verificação de Worker 
		if (!isSupportedBrowsers()) {
			return elem;
		}
		realInit(elem, conf);

		return elem;
	}

	function realInit(elem, conf){
		if(!elem.getAttribute('player')){
			var player = new vPlayer.Player(elem, conf);

			try {
				var event = new CustomEvent("player.ready",  {'detail': player});
			} catch (e) {
				var event = document.createEvent("Event");
				event.detail = player;
				event.initEvent("player.ready", true, false);
			}
			elem.dispatchEvent(event);
			//mobile.analyticsEvents('vPlayer','Init');
		}
	}

	// Isso faz os outros ng-clicks não funcionarem
	// Comentando aqui, o vídeo Youtube não funciona

	var makeID = function(){
		return 'v_'+this.modules.createID();
	}

	// Controller
	/**
	 * Playerv3
	 * @param {DOM} $elem // Parametro obrigatório, sendo o seletor onde será inserido o Player
	 * @param {obj} conf  // Parametro opcional, sendo configurações opcionais do player
	 */

	var Player = function(elem, conf){
		// Todos os defaults de load do Player
		this.defaults = {
			autoPlay:false,
			currentSong: false,
			repeat: false,
			dimensions:'default',
			category: false,
			isPlaylisteiros: false
		};

		for(var name in conf){
			if(this.defaults.hasOwnProperty(name)){
				this.defaults[name] = conf[name];
			}
		}

		// Local de instancias
		this.instances = {};

		// Funções publicas presa no elemento
		(this.target = elem).vPlayer = this;

		// Instancia o modules
		this.modules = new vPlayer.modules.Init(this);

		// Cria ID do player
		this.id = makeID.call(this);

		// Instancia o front
		this.front = new vPlayer.front.Init(this);

		// Instancia o core
		this.core = new vPlayer.core.Init(this);

	};

	Player.prototype = {
		play:function(){
			// Chamada para o play
			this.core.play();
		},
		pause:function(){
			// Chamada para o pause
			this.core.pause();
		},
		isPlaying:function(){
			return this.core.isPlaying();
		},
		loadAndPlay: function(conf) {
			this.core.loadAndPlay(conf);
		},
		getCurrentSong:function(){
			// Retorna a música corrente
			return this.modules.getObjSong();
		},
		getCurrentPlaylist:function(){
			// Retorna a lista de objetos
			return this.defaults.currentPlaylist;
		},
		getDuration:function(){
			// Retorna a lista de objetos
			return this.youtube.getDuration();
		}
	}

	vPlayer.Player = Player;
})(window.vPlayer);

/*
* mobile-vplayer-core.js
*/

window.vPlayer = vPlayer || {};
window.vPlayer.core = vPlayer.core || {};

(function(v){

	v.Init = function(player){
		// Inicia a playlist
		this.initCurrentPlaylist = function() {
			// Inicia os eventos do core
			this.setEvents()
			var currentSong = player.defaults.currentSong
			if (typeof currentSong === "object" && Object.keys(currentSong).length) {
				// Carrega o serviço para tocar
				this.loadService();
			}
		}

		// Função que verificar o Formato do serviço e chama o play
		this.play = function(){
			var typeService = player.modules.getFormatService(player.defaults.currentSong);
			player[typeService] && player[typeService].play();
		}

		// Função que verificar o Formato do serviço e chama o pause
		this.pause = function(){
			var typeService = player.modules.getFormatService(player.defaults.currentSong);
			player[typeService].pause();
		}

		// Função para parar a música
		this.stop = function(){
			var typeService = player.modules.getFormatService(player.defaults.currentSong);
			try {
				player[typeService].stop()
			} catch (e) {}
		}

		// Função para setar o progressBar do player
		this.setProgressbar = function(calc){
			var typeService = player.modules.getFormatService(player.defaults.currentSong)
			,   duration = player[typeService].getDuration();
			player[typeService].setProgressbar(calc * duration)
		}

		// Função para setar o volume e guardar no localstorage
		this.setVolume = function(calc){
			calc = calc >= 0 && calc <= 1  ? parseFloat(calc).toFixed(2) : 1;
			var typeService = player.modules.getFormatService(player.defaults.currentSong)
			player[typeService].setVolume(calc);
			player.modules.setVolumeByLocalStorage(calc);
			player.front.controls.setVolume(calc * 100);
		}

		this.setDuration = function() {
			var duration = this.getDuration();
			player.front.controls.setDuration(duration);
		}

		// Retorna o volume do play
		this.getVolume = function() {
			var typeService = player.modules.getFormatService(player.defaults.currentSong)
			return player[typeService].getVolume();
		}

		this.getAllQualityVideo = function() {
			var typeService = player.modules.getFormatService(player.defaults.currentSong)
			,   allQuality = player[typeService].getAllVideoQuality()
			,   obj = {};
			for (var i = 0; i < allQuality.length; i++) {
				obj[this.getQualityName(allQuality[i])] = allQuality[i];
			};
			
			return obj;
		}

		this.getQualityVideo = function() {
			var typeService = player.modules.getFormatService(player.defaults.currentSong)
			return player[typeService].getVideoQuality();
		}

		this.getQualityName = function(quality) {
			if (!quality) {quality = this.getQualityVideo()};
			if (quality) {
				var qualityNames = {
					auto:    'auto',
					tiny:    '144p',
					small:   '240p',
					medium:  '360p',
					large:   '480p',
					hd720:   '720p',
					hd1080:  '1080p',
					hd1440:  '1440p',
					highres: '1080p+'
				}
				return qualityNames[quality] || false;
			}
			return false;
		}

		this.setQuality = function(quality){
			var typeService = player.modules.getFormatService(player.defaults.currentSong)
			player[typeService].setVideoQuality(quality);
		}

		// Retorna o volume do play
		this.getDuration = function(){
			var typeService = player.modules.getFormatService(player.defaults.currentSong)
			return player[typeService].getDuration();
		}

		// Função que verificar o Formato do serviço e chama o play
		this.loadAndPlay = function(conf){
			player.defaults.currentSong = conf || player.defaults.currentSong;
			player.core.loadService();
		}

		this.destroy = function() {
			var service = player.modules.getService();
			switch(service) {
				case 'youtube':
					player.instances.mediaYoutube = {};
				case 'vevo':
					player.instances.mediaVevo = {};
				break;
			}
		}


		// Função para instanciar o serviço
		this.loadService = function() {
			var service = player.modules.getService()
			// Verificar objeto
			if (!player.modules.isValidSong()) {
				// TODO: Fazer errorHandler
				return;
			}

			// Verificar source
			if (!player.modules.isValidSource()) {
				// TODO: Fazer errorHandler
				return;
			}

			// Pega o tipo do serviço para carregar o JS dele
			var formatService = player.modules.getFormatService()
			this.initService()
		}

		this.isPlaying = function() {
			var typeService = player.modules.getFormatService(player.defaults.currentSong)
			return typeService ? player.youtube.isPlaying() : false;
		}

		// Instanciar o serviço e verificar se o javascript está carregado
		this.initService = function() {
			// Pega o tipo do serviço para carregar o JS dele
			var formatService = player.modules.getCurrentFormatService();
			// Verificar se está instanciado
			if (player[formatService]) {
				player[formatService].loadPlayer(player);
			} else {
				player[formatService] = new vPlayer[formatService].Init(player);
			}
		}

		// Instancia e inicia o worker
		this.initWorker = function(obj){
			var initialize = function(feature){
				var map = new player.modules.Workermap()
				if (!map.worker) {
					map.worker = new Worker(player.modules.getURLForWorker(vPlayer.webworker.workerServices));
				}
				if (map.worker) {
					workerProtocol(map.worker,obj);
				}
			}
			initialize()
		}

		// Comunicação com o Worker
		var workerProtocol = function(worker,obj){
			// Caso esteja com o #vevo
			if (obj['data'] && location.hash.match(/vevo|VEVO/)) {
				obj['data']['vevoOk'] = true;
			}
			worker.postMessage(obj)
			return worker.onmessage = function(obj){
				var data = obj.data
				switch(data.message){
					case 'search':
						if(data.status == 'ok') {
							if(data.content.length) {
								var objSearch = player.modules.createObjSearch(data);
								// Renderizar opcoes da busca
								player.front.render({action:'listSearch','data':objSearch});
							} else {
								// Renderizar opcoes da busca
								player.front.render({action:'listSearch','data':{service:data.service}});
								setTimeout(function(){
									player.front.errors.searchError(data);
								}, 300)
							}
						} else {
							// Renderizar opcoes da busca
							player.front.render({action:'listSearch','data':{service:data.service}});
							setTimeout(function(){
								player.front.errors.searchError(data);
							}, 300)
						}
					break;
					case 'searchMore':
						var objSearch = player.modules.createObjSearch(data);
						// Renderizar opcoes da busca
						player.front.render({action:'listSearch','data':objSearch,'searchMore':true});
					break;
					case 'getValidSource':
					break;
					case 'searchAndChange':
						// Procura por sources para poder trocar e tocar o novo serviço
						if (data && data.content && data.content.length) {
							var obj = new player.modules.objValidSourceAndCount()
							obj.arraySongs = data.content
							obj.service = data.service
							player.modules.changeAndPlay()
						} else {
							// TODO: Sem músicas disponíveis
						}
					break;
					case 'imagesGallery':
						// Renderizar galeria
						// player.front.render({'action':'showGallery','data':data})
						// Avisar que trouxe novas fotos
						player.target.trigger('player.gallery',[data]);
					break;
					case 'imagesAlbum':
						player.front.imagesAlbum(data);
						// Avisar que trouxe informaçoes do album da musica corrente
						player.target.trigger('player.album',[data])
					break;
					case 'urlAlbum':
						player.front.imagesAlbum(data);
					break;
					case 'imagesProfile':
						// Renderizar Profile
						// Avisar que trouxe informaçoes do album da musica corrente
						player.target.trigger('player.profile',[data])
					break;
					case 'getSubtitle':
						player.subtitle.controlSubtitle(data.content)
					break;
					case 'getRelatedSong':
						var content = data.content
						,   song    = player.modules.getObjSong();
						if (content && Object.keys(content).length) {
							if (content.mus[0].id == song.pointerID) {
								song['related']['songs'] = content.mus[0].related;
							}
						}
					break;
					default:
						//code to be executed if n is different from case 1 and 2
				}
			}
		}
		
		// EVENTOS // 
		this.setEvents = function() {
			var contentVPlayer = document.getElementById(player.id);
			
			player.modules.watch(contentVPlayer, 'canplay.core', function() {
				player.modules.fire(player.target, 'player.canplay');
			})
			player.modules.watch(contentVPlayer, 'play.core', function() {
				try{
					mobile.analyticsEvents('vPlayer / Play',player.modules.getCurrentService(),player.defaults.currentSong.source);
				}catch(e){}
				player.modules.fire(player.target, 'player.play');
			})
			player.modules.watch(contentVPlayer, 'pause.core', function() {
				try{
					mobile.analyticsEvents('vPlayer / Pause',player.modules.getCurrentService(),player.defaults.currentSong.source);
				}catch(e){}
				player.modules.fire(player.target, 'player.pause');
			})
			player.modules.watch(contentVPlayer, 'buffering.core', function() {
				player.modules.fire(player.target, 'player.buffering');
			})
			player.modules.watch(contentVPlayer, 'error.core', function() {
				try{
					mobile.analyticsEvents('vPlayer / Error',player.modules.getCurrentService(),player.defaults.currentSong.source);
				}catch(e){}
				player.modules.fire(player.target, 'player.error');
			})
			player.modules.watch(contentVPlayer, 'ended.core', function() {
				try{
					mobile.analyticsEvents('vPlayer / MusicEnd',player.modules.getCurrentService(),player.defaults.currentSong.source);
				}catch(e){}
				player.modules.fire(player.target, 'player.ended');		
			})
			player.modules.watch(contentVPlayer, 'playing.core', function() {
				try{
					mobile.analyticsEvents('vPlayer / Playing',player.modules.getCurrentService(),player.defaults.currentSong.source);
				}catch(e){}
			})
		}

		// Cria player
		player.front.render({action:'createPlayer'});
		this.initCurrentPlaylist();

	};
})(window.vPlayer.core)

/*
* mobile-vplayer-front.js
*/

window.vPlayer = window.vPlayer || {};
window.vPlayer.front = window.vPlayer.front || {};

(function(v){
	v.Init = function(player){

		var tplContainer = function(){
			var html = '<div id="'+player.id+'" class=vPlayer>'
			+   (player.defaults.isPlaylisteiros ? '<div class=canvas><canvas class=blur></div>' : '')
			+   '<div class=ContentPlayer>'
			+   '</div>'
			+'</div>'
			return html;
		}

		var tplPlayer = function(){
			var html = ''
			,   formatService = player.modules.getCurrentFormatService()
			if (formatService == "youtube") {
				html = template['youtube']()
			} else if (formatService == "vevo") {
				html = template['vevo']()
			}
			return html;
		}

		var tplYoutube = function() {
			var div = document.createElement('div');
			
			div.className = 'vContentYoutube';
			div.setAttribute("data-typeservice", "youtube");
			div.innerHTML = '<iframe id="iframeYoutube" src="http://api.vagalume.com.br/playerYoutubeAngular.html?id='+window.VideoID+'&auto=1&w=100%&h=100%"></iframe>';

			return div;
		}

		var tplVevo = function() {
			var div = document.createElement('div');
			
			div.className = 'vContentVevo';
			div.setAttribute("data-typeservice", "vevo");
			div.innerHTML = '<div id=playerVevo_'+player.id+'></div>';

			return div;
		}

		// Renderizar o DOM
		this.render = function(obj){
			var type = {
				createPlayer:function(){
					var html = template['container']()
					player.target.innerHTML += html;

					// Inicia os eventos
					player.front.setEvents();
					obj.cb && obj.cb();
				},
				contentPlayer:function() {
					var html = template['player']()
					,   div  = player.target.querySelector('.ContentPlayer');

					player.front.hide();
					document.querySelector('.ContentPlayer').appendChild(html);
					if (typeof obj.callback === "function") {
						obj.callback();
					}
				}
			}

			if(type.hasOwnProperty(obj.action)){
				type[obj.action]();
			}
		}

		// Função para setar os controles do player
		this.controls = {
			elem:function(){
				this.elem.dom = this.elem.dom ? this.elem.dom : document.getElementById(player.id);
				return this.elem.dom;
			},
		}

		// Variável do modulo de template
		var template = {
			'container':tplContainer,
			'player':tplPlayer,
			'youtube':tplYoutube,
			'vevo':tplVevo
		}

		this.hide = function() {
			var divs = document.querySelectorAll('.ContentPlayer > div');
			for (var i = 0; i < divs.length; i++) {
				divs[i].classList.add('hide');
			};
		}

		this.show = function(service) {
			var div = document.querySelector('.ContentPlayer > div[data-typeservice="'+service+'"]');
			div.classList.remove('hide');
		}

		this.setEvents = function() {
			// Manipular eventos do DOM
			var contentPlayer = document.getElementById(player.id);
		}

		this.updateCanvas = function(url){
			if (!url) return;
			var vPlayer = player.target.querySelector('#'+player.id)
			,   width  = vPlayer.offsetWidth
			,   height = vPlayer.offsetHeight
			,   canvas = vPlayer.querySelector('.blur')
			,   blur = 15;
			CanvasImage = function (e, t) {
				this.image = t;
				this.element = e;
				e.width = width
				e.height = height
				this.context = e.getContext("2d");
				this.context.drawImage(t, 0, 0, width, height);
			};
			CanvasImage.prototype = {
				blur:function(e) {
					this.context.globalAlpha = 0.5;
					for(var t = -e; t <= e; t += 5) {
						for(var n = -e; n <= e; n += 5) {
							this.context.drawImage(this.element, n, t);
							var blob = n >= 0 && t >= 0 && this.context.drawImage(this.element, -(n-1), -(t-1));
						}
					}
				}
			};

			var image = new Image();
			image.onload = function() {
				var canvasImage = new CanvasImage(canvas, this);
				canvasImage.blur(blur);
			};
			url = 'http://s2.vagalume.com'+url;
			image.src = url;
		}
	};

})(window.vPlayer.front)

/*
* mobile-vplayer-modules.js
*/

window.vPlayer = window.vPlayer || {};
window.vPlayer.modules = window.vPlayer.modules || {};
window.vPlayer.webworker = window.vPlayer.webworker || {};

(function(v){

	v.Init = function(player){
		this.createID = function(){
			return ((new Date()).getTime()*Math.round(Math.random()*10000)).toString(36);
		}

		// Pegar o objeto que está tocando
		this.getObjSong = function() {
			return player.defaults.currentSong;
		}

		// Pegar o objeto pelo pointerID
		this.getObjSongByPointerIDFromPlaylist = function(pointerID) {
			var index = this.getIndexByPointerIDFromPlaylist(pointerID);
			return player.defaults.currentPlaylist[index];
		}

		this.getPointerIDByCurrentSong = function() {
			return this.getObjSong().pointerID;
		}

		// Pegar o indice pelo pointerID
		this.getIndexByPointerIDFromPlaylist = function(pointerID,array) {
			var playCurrent = player.defaults.currentPlaylist
			,   array = []
			for (var i = 0; i < playCurrent.length; i++) {
				if (playCurrent[i].pointerID == pointerID) {
					if (!array) {
						return i;
					}
					array.push(i);
				}
			};
			return array.length ? array : false;
		}

		this.getTitleByCurrentSong = function() {
			var objSong = this.getObjSong()
			,   ret = false;
			if (objSong.band && objSong.title) {
				ret = objSong.band + " - " + objSong.title;
			}
			return ret;
		}

		// Shuffle na música e retorna o pointerID
		this.shuffleSong = function(indexPlaying) {
			var shufflePlaylist = player.defaults.shufflePlaylist;

			// Caso for a ultima música e for repeatAll
			if(shufflePlaylist.length == 1 && player.defaults.repeat == 'all') {
				this.shufflePlaylist();
			} else {
				shufflePlaylist.splice(shufflePlaylist.indexOf(indexPlaying), 1);
			}
			var retIndex = player.defaults.shufflePlaylist[Math.floor((Math.random()*(player.defaults.shufflePlaylist.length)))];
			return retIndex;
		}

		// Cria a playlist de músicas randomicas
		this.shufflePlaylist = function() {
			var array = [];
			for (var i = player.defaults.currentPlaylist.length - 1; i >= 0; i--) {
				array[i] = i;
			};

			var currentIndex = array.length,
				temporaryValue,
				randomIndex;

			while (0 !== currentIndex) {
				randomIndex = Math.floor(Math.random() * currentIndex);
				currentIndex -= 1;

				temporaryValue = array[currentIndex];
				array[currentIndex] = array[randomIndex];
				array[randomIndex] = temporaryValue;
			}

			player.defaults.shufflePlaylist = array;
		}

		this.getNext = function(obj) {
			if (!obj || (obj && typeof obj != "object")) return false;

			var currentSong = player.defaults.currentSong
			,   forceNext   = (obj.force ? obj.force : false)
			,   initCurrent = currentSong
			,   that        = this;
			var updateCurrent = function(repeat) {
				return that.getNextValid(repeat);
			}

			// Se for shuffle
			if (player.defaults.shuffle && player.defaults.repeat != "song") {
				// Se for shuffle
				currentSong = this.shuffleSong(currentSong)
			} else {
				// Se for repeat
				if (player.defaults.repeat) {
					if (forceNext || player.defaults.repeat == 'all') {
						currentSong = updateCurrent(true);
					}
				} else {
					currentSong = updateCurrent();
					if (initCurrent == currentSong) {
						$('#'+player.id).trigger('endedPlaylist.core')
						return;
					}
				}
			}
			player.defaults.currentSong = currentSong;
			player.core.loadAndPlay()
		}

		this.getNextValid = function() {
			player.modules.fire(player.target, 'player.next');
		}

		// Retorna o obj a partir do id da legenda
		this.getObjByLangID = function(obj,langID) {
			for (var x = 0, xx = obj.length; x < xx; x++) {
				if (obj[x].langID == langID) {
					return obj[x];
				}
			}
			return false;
		}

		// Atualiza o currentSong
		this.updateIndex = function(index) {
			if (!index && index != 0) return false;
			player.defaults.currentSong = index;
			return;
		}

		this.getDurationByCurrentSong = function() {
			var typeService = this.getFormatService()
			return player[typeService].getDuration();
		}

		// Atualiza o currentSong
		this.updateCurrentSongByPointerID = function(pointerID) {
			var index = this.getIndexByPointerIDFromPlaylist(pointerID);
			this.updateIndex(index);
			return;
		}

		// Obter a playlist atual
		this.getPlaylist = function(){
			return player.defaults.currentPlaylist;
		}

		// Função para retornar o serviço pelo indice da lista de reprodução
		this.getService = function() {
			return player.defaults.currentSong.service;
		}

		this.getListServices = function(){
			return videoService().concat(audioService());
		}

		this.prepareObjSearch = function(data,service) {
			var ret = false
			,   obj = {}
			if (data && Object.keys(data).length) {
				var objValid = new player.modules.objValidSourceAndCount()
				,   content = data[objValid.count];
				if (content) {
					obj.service = service;
					obj.url     = content.url;
					obj.ext     = content.ext;
					ret = obj;
				}
			}
			return ret;
		}

		// Função para retornar o tipo do serviço do JS
		this.getFormatService = function() {
			var service = this.getService()
			,   typeService = service;
			// Verificar se caso é audio
			if (audioService().indexOf(service) != -1) {
				typeService = 'audio'
			}
			return typeService;
		}

		// Função para retornar o tipo do serviço corrent do JS
		this.getCurrentFormatService = function() {
			return this.getFormatService();
		}

		// Função para retornar o serviço corrent do JS
		this.getCurrentService = function() {
			var currentSong = player.defaults.currentSong;
			return this.getService(currentSong);
		}

		// Função para validar serviço
		this.isValidService = function(service) {
			var ret = false
			,   totalService = player.modules.getListServices();
			if (totalService.indexOf(service) != -1) {
				ret = true;
			}
			return ret;
		}

		// Função para validar objeto
		this.isValidSong = function() {
			var ret = false
			,   objSong = this.getObjSong();
			if (this.isValidService(objSong.service)) {
				ret = true;
			}
			return ret;
		}

		// Função para validar source
		this.isValidSource = function() {
			var ret = false
			,   objSong = this.getObjSong();
			if (objSong.source) {
				return true;
			}
			return ret;
		}

		// Converter secundos ou milesegundos para hora minuto e segundo
		this.convertTime = function(duration,type) {
			if(type == 'seconds'){
				var seconds = parseInt(duration %60)
				,   minutes = parseInt(duration / 60)%60
				,   hours = parseInt(duration / 3600)%24;
			}else{
				var seconds = parseInt((duration/1000)%60)
				,   minutes = parseInt((duration/(1000*60))%60)
				,   hours = parseInt((duration/(1000*60*60))%24);
			}
			hours = (hours < 10) ? "0" + hours : hours;
			minutes = (minutes < 10) ? "0" + minutes : minutes;
			seconds = (seconds < 10) ? "0" + seconds : seconds;

			return ((hours == 00) ? '' : hours+ ':') + minutes + ":" + seconds;
		}

		// Retorna o buffer
		this.getPercentBuffer = function(obj) {
			var percent = 0;
			if (obj && obj.buffered.end && obj.duration) {
				percent = obj.buffered.end(0) / obj.duration;
			}
			if (percent) {
				percent = Math.round(100 * Math.min(1, Math.max(0, percent)));
			}
			return percent;
		}

		// Retorna o valor do volume configurado
		this.getVolumeByLocalStorage = function() {
			var volume = 1
			,   localVolume = localStorage.getItem('playerSound');
			if (localVolume && localVolume <= 1 && localVolume >= 0) {
				volume = localVolume;
			}
			return volume;
		}

		// Seta um valor de volume no localStorage
		this.setVolumeByLocalStorage = function(value) {
			var volume = 1;
			if (value && value <= 1 && value >= 0) {
				volume = value;
			}
			localStorage.setItem('playerSound',volume);
		}

		this.callList = function(obj){
			// Obter serviço da música atual ou do parâmetro
			obj.service = obj.service ? obj.service : this.getCurrentFormatService();
			obj.data = obj.data ? obj.data : this.getObjSong()
			// Carregar e iniciar Worker
			player.core.initWorker({
				'message':'search',
				'service':obj.service,
				'data':obj.data
			})

		}

		// Mandar log de error
		this.saveLogError = function(error) {
			var song = player.modules.getObjSong()
			,   url = 'http://backend.vagalume.com.br/report?'
			+'service='+song.service
			+'&pointerID='+ song.pointerID
			+'&source=' + encodeURIComponent(song.source)
			+(error ? '&error='+error : '');
			$.get(url);

			// Google Analytics
			mobile.analyticsEvents('vPlayer3 / Error',song.service,song.band+' - '+song.title+(error ? ' / '+error : ''));
		}

		// Função do vagalume.js para escapar html
		this.htmlEntities = function(string, quote_style, flagDecode) {
			// http://kevin.vanzonneveld.net
			// *     example 1: htmlentities('Kevin & van Zonneveld');
			// *     returns 1: 'Kevin &amp; van Zonneveld'
			// *     example 2: htmlentities("foo'bar","ENT_QUOTES");
			// *     returns 2: 'foo&#039;bar'
			// *     flagDecode: caso TRUE, tira a codificação das entidades.

			flagDecode = (flagDecode !== undefined && flagDecode !== null && flagDecode !== false && flagDecode !== void(0));
			if(!string) return '';

			var hash_map = {}, symbol = '', tmp_str = '', entity = '';
			tmp_str = string.toString();

			if (false === (hash_map = this.get_html_translation_table('HTML_ENTITIES', quote_style))) {
				return false;
			}
			hash_map["'"] = '&#039;';
			for (symbol in hash_map) {
				entity = hash_map[symbol];
				var codeOut = (flagDecode ? entity : symbol),
				codeIn = (flagDecode ? symbol : entity);
				tmp_str = tmp_str.split(codeOut).join(codeIn);
			}
			return tmp_str;
		};

		this.get_html_translation_table = function(table, quote_style) {
			// http://kevin.vanzonneveld.net
			// *     example 1: get_html_translation_table('HTML_SPECIALCHARS');
			// *     returns 1: {'"': '&quot;', '&': '&amp;', '<': '&lt;', '>': '&gt;'}

			var entities, hash_map={}, decimal=0, symbol='', constMappingTable = {},
				constMappingQuoteStyle = {}, useTable = {}, useQuoteStyle = {};

			// Translate arguments
			constMappingTable[0]      = 'HTML_SPECIALCHARS';
			constMappingTable[1]      = 'HTML_ENTITIES';
			constMappingQuoteStyle[0] = 'ENT_NOQUOTES';
			constMappingQuoteStyle[2] = 'ENT_COMPAT';
			constMappingQuoteStyle[3] = 'ENT_QUOTES';

			useTable       = !isNaN(table) ? constMappingTable[table] : table ? table.toUpperCase() : 'HTML_SPECIALCHARS';
			useQuoteStyle = !isNaN(quote_style) ? constMappingQuoteStyle[quote_style] : quote_style ? quote_style.toUpperCase() : 'ENT_COMPAT';

			if (useTable !== 'HTML_SPECIALCHARS' && useTable !== 'HTML_ENTITIES') {
				throw new Error("Table: "+useTable+' not supported');
				// return false;
			}
			var entities = {
				'38':'&amp;',
				'60':'&lt;',
				'62':'&gt;'
			};
			if (useQuoteStyle !== 'ENT_NOQUOTES') entities['34'] = '&quot;';
			if (useQuoteStyle === 'ENT_QUOTES')   entities['39'] = '&#39;';

			// ascii decimals to real symbols
			for (decimal in entities) {
				symbol = String.fromCharCode(decimal);
				hash_map[symbol] = entities[decimal];
			}
			return hash_map;
		};

		// Converte String para MD5
		this.MD5 = function (string) {

			function RotateLeft(lValue, iShiftBits) {
				return (lValue<<iShiftBits) | (lValue>>>(32-iShiftBits));
			}

			function AddUnsigned(lX,lY) {
				var lX4,lY4,lX8,lY8,lResult;
				lX8 = (lX & 0x80000000);
				lY8 = (lY & 0x80000000);
				lX4 = (lX & 0x40000000);
				lY4 = (lY & 0x40000000);
				lResult = (lX & 0x3FFFFFFF)+(lY & 0x3FFFFFFF);
				if (lX4 & lY4) {
					return (lResult ^ 0x80000000 ^ lX8 ^ lY8);
				}
				if (lX4 | lY4) {
					if (lResult & 0x40000000) {
						return (lResult ^ 0xC0000000 ^ lX8 ^ lY8);
					} else {
						return (lResult ^ 0x40000000 ^ lX8 ^ lY8);
					}
				} else {
					return (lResult ^ lX8 ^ lY8);
				}
			}

			function F(x,y,z) { return (x & y) | ((~x) & z); }
			function G(x,y,z) { return (x & z) | (y & (~z)); }
			function H(x,y,z) { return (x ^ y ^ z); }
			function I(x,y,z) { return (y ^ (x | (~z))); }

			function FF(a,b,c,d,x,s,ac) {
				a = AddUnsigned(a, AddUnsigned(AddUnsigned(F(b, c, d), x), ac));
				return AddUnsigned(RotateLeft(a, s), b);
			};

			function GG(a,b,c,d,x,s,ac) {
				a = AddUnsigned(a, AddUnsigned(AddUnsigned(G(b, c, d), x), ac));
				return AddUnsigned(RotateLeft(a, s), b);
			};

			function HH(a,b,c,d,x,s,ac) {
				a = AddUnsigned(a, AddUnsigned(AddUnsigned(H(b, c, d), x), ac));
				return AddUnsigned(RotateLeft(a, s), b);
			};

			function II(a,b,c,d,x,s,ac) {
				a = AddUnsigned(a, AddUnsigned(AddUnsigned(I(b, c, d), x), ac));
				return AddUnsigned(RotateLeft(a, s), b);
			};

			function ConvertToWordArray(string) {
				var lWordCount;
				var lMessageLength = string.length;
				var lNumberOfWords_temp1=lMessageLength + 8;
				var lNumberOfWords_temp2=(lNumberOfWords_temp1-(lNumberOfWords_temp1 % 64))/64;
				var lNumberOfWords = (lNumberOfWords_temp2+1)*16;
				var lWordArray=Array(lNumberOfWords-1);
				var lBytePosition = 0;
				var lByteCount = 0;
				while ( lByteCount < lMessageLength ) {
					lWordCount = (lByteCount-(lByteCount % 4))/4;
					lBytePosition = (lByteCount % 4)*8;
					lWordArray[lWordCount] = (lWordArray[lWordCount] | (string.charCodeAt(lByteCount)<<lBytePosition));
					lByteCount++;
				}
				lWordCount = (lByteCount-(lByteCount % 4))/4;
				lBytePosition = (lByteCount % 4)*8;
				lWordArray[lWordCount] = lWordArray[lWordCount] | (0x80<<lBytePosition);
				lWordArray[lNumberOfWords-2] = lMessageLength<<3;
				lWordArray[lNumberOfWords-1] = lMessageLength>>>29;
				return lWordArray;
			};

			function WordToHex(lValue) {
				var WordToHexValue="",WordToHexValue_temp="",lByte,lCount;
				for (lCount = 0;lCount<=3;lCount++) {
					lByte = (lValue>>>(lCount*8)) & 255;
					WordToHexValue_temp = "0" + lByte.toString(16);
					WordToHexValue = WordToHexValue + WordToHexValue_temp.substr(WordToHexValue_temp.length-2,2);
				}
				return WordToHexValue;
			};

			function Utf8Encode(string) {
				string = string.replace(/\r\n/g,"\n");
				var utftext = "";

				for (var n = 0; n < string.length; n++) {

					var c = string.charCodeAt(n);

					if (c < 128) {
						utftext += String.fromCharCode(c);
					}
					else if((c > 127) && (c < 2048)) {
						utftext += String.fromCharCode((c >> 6) | 192);
						utftext += String.fromCharCode((c & 63) | 128);
					}
					else {
						utftext += String.fromCharCode((c >> 12) | 224);
						utftext += String.fromCharCode(((c >> 6) & 63) | 128);
						utftext += String.fromCharCode((c & 63) | 128);
					}

				}

				return utftext;
			};

			var x=Array();
			var k,AA,BB,CC,DD,a,b,c,d;
			var S11=7, S12=12, S13=17, S14=22;
			var S21=5, S22=9 , S23=14, S24=20;
			var S31=4, S32=11, S33=16, S34=23;
			var S41=6, S42=10, S43=15, S44=21;

			string = Utf8Encode(string);

			x = ConvertToWordArray(string);

			a = 0x67452301; b = 0xEFCDAB89; c = 0x98BADCFE; d = 0x10325476;

			for (k=0;k<x.length;k+=16) {
				AA=a; BB=b; CC=c; DD=d;
				a=FF(a,b,c,d,x[k+0], S11,0xD76AA478);
				d=FF(d,a,b,c,x[k+1], S12,0xE8C7B756);
				c=FF(c,d,a,b,x[k+2], S13,0x242070DB);
				b=FF(b,c,d,a,x[k+3], S14,0xC1BDCEEE);
				a=FF(a,b,c,d,x[k+4], S11,0xF57C0FAF);
				d=FF(d,a,b,c,x[k+5], S12,0x4787C62A);
				c=FF(c,d,a,b,x[k+6], S13,0xA8304613);
				b=FF(b,c,d,a,x[k+7], S14,0xFD469501);
				a=FF(a,b,c,d,x[k+8], S11,0x698098D8);
				d=FF(d,a,b,c,x[k+9], S12,0x8B44F7AF);
				c=FF(c,d,a,b,x[k+10],S13,0xFFFF5BB1);
				b=FF(b,c,d,a,x[k+11],S14,0x895CD7BE);
				a=FF(a,b,c,d,x[k+12],S11,0x6B901122);
				d=FF(d,a,b,c,x[k+13],S12,0xFD987193);
				c=FF(c,d,a,b,x[k+14],S13,0xA679438E);
				b=FF(b,c,d,a,x[k+15],S14,0x49B40821);
				a=GG(a,b,c,d,x[k+1], S21,0xF61E2562);
				d=GG(d,a,b,c,x[k+6], S22,0xC040B340);
				c=GG(c,d,a,b,x[k+11],S23,0x265E5A51);
				b=GG(b,c,d,a,x[k+0], S24,0xE9B6C7AA);
				a=GG(a,b,c,d,x[k+5], S21,0xD62F105D);
				d=GG(d,a,b,c,x[k+10],S22,0x2441453);
				c=GG(c,d,a,b,x[k+15],S23,0xD8A1E681);
				b=GG(b,c,d,a,x[k+4], S24,0xE7D3FBC8);
				a=GG(a,b,c,d,x[k+9], S21,0x21E1CDE6);
				d=GG(d,a,b,c,x[k+14],S22,0xC33707D6);
				c=GG(c,d,a,b,x[k+3], S23,0xF4D50D87);
				b=GG(b,c,d,a,x[k+8], S24,0x455A14ED);
				a=GG(a,b,c,d,x[k+13],S21,0xA9E3E905);
				d=GG(d,a,b,c,x[k+2], S22,0xFCEFA3F8);
				c=GG(c,d,a,b,x[k+7], S23,0x676F02D9);
				b=GG(b,c,d,a,x[k+12],S24,0x8D2A4C8A);
				a=HH(a,b,c,d,x[k+5], S31,0xFFFA3942);
				d=HH(d,a,b,c,x[k+8], S32,0x8771F681);
				c=HH(c,d,a,b,x[k+11],S33,0x6D9D6122);
				b=HH(b,c,d,a,x[k+14],S34,0xFDE5380C);
				a=HH(a,b,c,d,x[k+1], S31,0xA4BEEA44);
				d=HH(d,a,b,c,x[k+4], S32,0x4BDECFA9);
				c=HH(c,d,a,b,x[k+7], S33,0xF6BB4B60);
				b=HH(b,c,d,a,x[k+10],S34,0xBEBFBC70);
				a=HH(a,b,c,d,x[k+13],S31,0x289B7EC6);
				d=HH(d,a,b,c,x[k+0], S32,0xEAA127FA);
				c=HH(c,d,a,b,x[k+3], S33,0xD4EF3085);
				b=HH(b,c,d,a,x[k+6], S34,0x4881D05);
				a=HH(a,b,c,d,x[k+9], S31,0xD9D4D039);
				d=HH(d,a,b,c,x[k+12],S32,0xE6DB99E5);
				c=HH(c,d,a,b,x[k+15],S33,0x1FA27CF8);
				b=HH(b,c,d,a,x[k+2], S34,0xC4AC5665);
				a=II(a,b,c,d,x[k+0], S41,0xF4292244);
				d=II(d,a,b,c,x[k+7], S42,0x432AFF97);
				c=II(c,d,a,b,x[k+14],S43,0xAB9423A7);
				b=II(b,c,d,a,x[k+5], S44,0xFC93A039);
				a=II(a,b,c,d,x[k+12],S41,0x655B59C3);
				d=II(d,a,b,c,x[k+3], S42,0x8F0CCC92);
				c=II(c,d,a,b,x[k+10],S43,0xFFEFF47D);
				b=II(b,c,d,a,x[k+1], S44,0x85845DD1);
				a=II(a,b,c,d,x[k+8], S41,0x6FA87E4F);
				d=II(d,a,b,c,x[k+15],S42,0xFE2CE6E0);
				c=II(c,d,a,b,x[k+6], S43,0xA3014314);
				b=II(b,c,d,a,x[k+13],S44,0x4E0811A1);
				a=II(a,b,c,d,x[k+4], S41,0xF7537E82);
				d=II(d,a,b,c,x[k+11],S42,0xBD3AF235);
				c=II(c,d,a,b,x[k+2], S43,0x2AD7D2BB);
				b=II(b,c,d,a,x[k+9], S44,0xEB86D391);
				a=AddUnsigned(a,AA);
				b=AddUnsigned(b,BB);
				c=AddUnsigned(c,CC);
				d=AddUnsigned(d,DD);
			}

			var temp = WordToHex(a)+WordToHex(b)+WordToHex(c)+WordToHex(d);

			return temp.toLowerCase();
		}

		// Criar objeto espelho e filtra objeto do search
		this.createObjSearch = function(data){
			var item = data.content
			,   service = data.service
			,   ret = {}
			if (!item) return;
			for (var i = 0; i < item.length; i++) {
				var url = this.MD5(item[i].url)
				,   newObj = {
					'service':service
				}
				newObj = $.extend({}, newObj, item[i]);
				ret[url] = newObj;
			};
			data.content = ret;
			var objSearch = new this.objSearch();
			// objSearch.clear()
			objSearch.add(ret);
			return data;
		}

		// Obtem Objeto do search passando MD5 como parametro
		this.getObjSearch = function(md5){
			var objSearch = new this.objSearch();
			return objSearch.get(md5);
		}

		this.getURLForWorker = function(workerFunction) {
			URL             = window.URL || window.webkitURL,
			mainString      = workerFunction.toString(),
			bodyString      = mainString.substring( mainString.indexOf("{")+1, mainString.lastIndexOf("}") )
			bb              = new Blob([bodyString],{type:'text/javascript'})
			return URL.createObjectURL(bb)
		}

		// Objeto Espelho do Search
		this.objSearch = (function() {
			var instance;
			objSearch = function() {
				if (instance) {
					return instance;
				}
				instance = this;
				this.search = {}
			};
			// TODO: a cada mudança de busca e novas musicas, dar clear
			objSearch.prototype.clear = function(){
				this.search = {};
			}

			objSearch.prototype.get = function(md5){
				if(!md5) return false;

				return this.search[md5];
			}

			objSearch.prototype.add = function(obj){
				this.search = $.extend(true, this.search, obj);

			}
			return objSearch;

		}());

		// Objeto de timeout do item da playlist
		this.timeoutBalloon = (function() {
			var instance;
			timeoutBalloon = function() {
				if (instance) {
					return instance;
				}
				instance = this;
				this.timeout = 0;
				this.hover = false;
			};
			timeoutBalloon.prototype.clear = function(){
				clearTimeout(this.timeout);
				$(this.hover).removeClass('hover')
			}

			return timeoutBalloon; 
		}());

		this.changeAndPlay = function() {
			var objSong = new player.modules.objValidSourceAndCount();
			player.core.loadAndPlay({
				source: objSong.arraySongs[0].url,
				service: objSong.service
			});
		}

		this.changeService = function() {
			var currentService = this.getService();
			switch(currentService) {
				case 'vevo':
					player.core.initWorker({
						'data'   : player.modules.getObjSong(),
						'message': 'searchAndChange',
						'service': 'youtube'
					})
					break;
			}
		}

		// Atualiza música corrente com o novo objeto passado
		this.updateCurrentSongBySearch = function(obj){
			if (!obj || !Object.keys(obj).length) return;
			var objSong = obj.id ? this.getObjSearch(obj.id) : obj
			,   newObj = this.getObjSong();

			newObj['service'] = objSong.service
			newObj['source'] = objSong.url
			if(newObj['service'] != 'youtube'){
				newObj['ext'] = objSong.ext
			}
			var song = player.defaults.currentSong
			player.defaults.currentSong = newObj;

			return true;
		}

		this.getValidSource = function() {
			var objValid = new player.modules.objValidSourceAndCount()
			,   objSong  = player.modules.getObjSong()

			// Limpar dados
			if (objSong.service != objValid.service || objSong.pointerID != objValid.pointerID) {
				objValid.clear();
			}

			if (objValid.arraySongs && objValid.arraySongs.length) {
				var obj = player.modules.prepareObjSearch(objValid.arraySongs,objValid.service);
				if (obj) {
					player.modules.updateCurrentSongBySearch(obj);
					objValid.count++;
					// TOCAR MUSICA
					player.core.loadAndPlay();
				} else {
					// TODO: Fazer errorHandler
				}
			} else {
				player.core.initWorker({
					'data'   : player.modules.getObjSong(),
					'message': 'getValidSource',
					'service': player.modules.getCurrentService()
				})
			}
		}

		// Singleton para pegar a proxima música via worker
		this.objValidSourceAndCount = (function() {
			var instance;
			objValidSourceAndCount = function() {
				if (instance) {
					return instance;
				}
				instance = this;
				this.count = 0;
				this.service = '';
				this.pointerID  = '';
				this.arraySongs = [];
				this.clear = function(){
					this.count = 0;
					this.arraySongs = []
					this.service = '';
					this.pointerID  = '';
				}
			};
			return objValidSourceAndCount;

		}());

		// Array de audios validos
		var audioService = function() {
			return [];
		}

		// Array de serviços validos
		var videoService = function () {
			return ['vagalume','youtube','vevo']
		}

		this.loadMoreVideos = function() {
			var webWorkerUrl = '/js/mobile-worker_itunes.js'
			,   obj = {
				descr: pointer,
				entity: 'song',
				attribute: 'songTerm',
				limit: 1,
				curpage: window.curPage
			};

			mobile.webWorker(webWorkerUrl,obj,function(obj){
				mobile.insertItunesPromo(obj.itunes)
			});
		}

		this.lazyInstance = function(W){
			// Atenção para IE<9 window.innerHeight não funciona, sendo usado document.documentElement.clientHeight
			function _innerHeight() { return (document.documentElement.clientHeight||document.body.clientHeight); }

			var _queue=[]
			,   _winHeight=parseInt(window.innerHeight||_innerHeight(),10)
			,   _setBind=true
			,   _continuous=false;

			// Passa a ouvir os eventos de onScroll e onResize do objeto window
			function _bind() {
				if (_setBind) {
					$(W).bind('resize.lazyLoad',function(){_winHeight=parseInt(W.innerHeight||_innerHeight(),10);})
					.bind('scroll.lazyLoad',_lazyListener);
					_setBind=false;
				}
			}

			// Para de ouvir eventos de onScroll e onResize do objeto window
			function _unbind() {
				$(W).unbind('resize.lazyLoad').unbind('scroll.lazyLoad');
				_queue=[];
				_setBind=true;
				return this;
			}

			// Torna a execução de callbacks assíncrona, liberando o fluxo dos loops
			function _lazyCallback(cback,elem) {
				setTimeout(function(){cback(elem);},1)
			}

			// Dispara verificações no dom e dispara callbacks quando necessário
			function _lazyListener(evnt){
				for (var i=0,il=_queue.length; i<il; i++) {
					var group = _queue[i].elems; // objeto jQuery contendo um grupo de elementos
					for (var g=0,gl=group.length; g<gl; g++) {
						if (group[g].getBoundingClientRect().top < _winHeight + _queue[i].threshold) {
							_lazyCallback(_queue[i].cback,group[g]);
							group.splice(g,1); --g; --gl; //substitui delete
						} else {
							if (_queue[i].lazyBreak) break;
						}
					}
					if (!group[0]) {
						_queue.splice(i,1); --i; --il; // substitui delete
					}
				}
				if (!_queue[0]) _unbind();
			}

			// Permite disparar os callbacks manualmente sem necessidade do evento
			function lazyRefresh () {
				_lazyListener(null);
			}

			// Coloca elementos na fila para verificação
			function lazyLoad(selector,cback,lazyBreak,threshold) {
				var lazyBreak=lazyBreak||true, // Padrão é varrer em loop e parar no primeiro além do threshold
				threshold=threshold||200,
				selector = typeof selector == 'string' ? [selector] : selector;
				_bind();

				for (var s=0,sl=selector.length; s<sl; s++) {
					var elems = $(selector[s]);
					if (!elems[0] || typeof cback != 'function') continue;
					_queue.push({
						elems:elems,
						cback:cback,
						lazyBreak:lazyBreak,
						threshold:threshold
					});
				}

				// Força execução para itens que já estejam na tela
				_lazyListener();
				return this;
			}

			// Público
			return {
				load:lazyLoad,
				refresh:lazyRefresh,
				unbind:_unbind
			}
		}

		// Função para guardar valor no localstorage com expire
		this.localStorageWithExpiration = function() {
			return {
				save : function(key, value, expirationMin){
					if (!window.localStorage) return false;
					if (!expirationMin) expirationMin = 5; // Default: 5 min

					var expirationMS = expirationMin * 60 * 1000
					,   record = {value: (typeof value == "object" ? JSON.stringify(value) : value), timestamp: new Date().getTime() + expirationMS}
					localStorage.setItem(key, JSON.stringify(record));
					return value;
				},
				load : function(key){
					if (!window.localStorage) return false;

					var value = localStorage.getItem(key)
					,   record = value ? JSON.parse(value) : false
					,   ret    = false;
					if (record) {
						if (new Date().getTime() < record.timestamp) {
							ret = JSON.parse(record.value);
						} else {
							localStorage.removeItem(key);
						}
					}
					return ret;
				}
			}
		}

		// Singleton para Worker
		this.Workermap = (function() {
			var instance, Workermap = function() {
				if (instance) {
					return instance;
				}
				instance = this;
				this.worker;
			};
			return Workermap;

		}());

		this.getURLForWorker = function(workerFunction) {
			var URL             = window.URL || window.webkitURL
			,  mainString      = workerFunction.toString()
			,  bodyString      = mainString.substring( mainString.indexOf("{")+1, mainString.lastIndexOf("}") )
			,  bb              = new Blob([bodyString],{type:'text/javascript'})
			return URL.createObjectURL(bb)
		}

		// Funções de escuta e gatilho de eventos
		this.watch = function(target, eventName, listener) {
			if(target instanceof Element){
				target.addEventListener(eventName, listener);
			} else {
				var map = (target.__events__ = (target.__events__ || {}));
				(map[eventName] = (map[eventName] || [])).push(listener);
			}
			return target;
		}
		this.watchOnce = function(target, eventName, listener) {
			if(target instanceof Element){
				target.addEventListener(eventName, listener);
			} else {
				var map = (target.__events__ = (target.__events__ || {}));
				(map[eventName] = (map[eventName] || [])).push(listener);
			}

			return target;
		}
		this.fire = function (target, event, detail) {
			if(target instanceof Element){
				if(typeof event == 'string'){
					try {
						event = new CustomEvent(event, detail || {});
					} catch (e) {
						var evt = event;
						event = document.createEvent("Event");
						event.detail = detail || {};
						event.initEvent(evt, true, false);
					}
				}
				target.dispatchEvent(event);
			} else {
				if(target.__events__){
					if(typeof event == 'string') event = {type:event};
					if(target.__events__[event.type]){
						var list = target.__events__[event.type];
						for(var i=0;i<list.length; i++){
							if(list[i].call(target, event) === false){
								event.isDefaultPrevented = true;
							}
						}
					}
				}
			}
			return target;
		}
		this.off = function(target, eventName, listener) {
			if(target instanceof Element){
				target.removeEventListener(eventName, listener);
			} else {
				if(target.__events__){
					if(target.__events__[eventName]){
						if(listener){
							var list = target.__events__[eventName]
							, newList = [];
							for(var i=0; i<list.length; i++){
								if(list[i] !== listener) newList.push(list[i]);
							}
							target.__events__[eventName] = newList;
						} else {
							target.__events__[eventName] = [];
						}
					}
				}
			}
			return target;
		}

	}
})(window.vPlayer.modules);

// WEB WORKER - SERVICES 
(function(webworker){
	webworker.workerServices = function() {
		var driveURL = 'https://drive.vagalume.com.br';
		var search = function(data) {
			switch(data.service){
				case 'youtube':
					loadYoutube(data);
				break;
				case 'vevo':
					loadVevo(data);
				break;
				case 'all':
					loadYoutube(data);
					loadVevo(data);
				break;
			}
		}

		var getValidSource = function(data) {
			search(data)
		}

		var loadYoutube = function(data) {
			var obj = data.data

			obj.text = obj.textFull ? obj.textFull : (obj.band + ' ' + obj.title).toLowerCase();
			obj.text = obj.text.replace(/"/g,' ').replace(/\s+/g,' ').replace(/^\s|\s$/g,'').toLowerCase();

			var key = [
				'maxResults=50',
				'orderby=relevance',
				'part=snippet',
				'q='+encodeURIComponent(obj.text),
				'type=video'
			].join('&');

			ajax(
				'https://proxy.vagalume.com.br/api/youtube-v3/search?'+key
				,data.message
				,resYoutube
				,'youtube'
			);
		}

		var resYoutube = function(ytRes,msgtype) {
			var items = ytRes.items || false
			,   itemsLength = items.length
			,   res=[]
			,   message = function() {
				msgFormater({
					'data':res,
					'message':msgtype,
					'service':'youtube'
				});
			}
			if (!items) {
				message();
				return;
			}
			for (var x=0; x < itemsLength; x++){
				var item = items[x]
				,   info = {};

				info.url = item.id.videoId;
				info.title = item.snippet.title || '';
				info.userName = item.snippet.channelTitle || '';
				info.href = 'https://www.youtube.com/watch?v=' + info.url;
				info.ext = 'youtube';
				info.extra = item
				if (! /cifra[^0-9a-z]*club|letras[^0-9a-z]*mus|studio[^0-9a-z]*sol/i.test(info.userName+info.title)) res.push(info);
			}
			message();
		}

		var loadVevo = function(data){
			var obj = data.data
			if (!obj.vevoOk) return;
			ajax(
				'http://app2.vagalume.com.br/vevoInfo.php?action=infoVideoByPointerID&pointerID='+obj.pointerID
				,data.message
				,resVevo
				,'vevo'
			)
		}

		var resVevo = function(data,msgtype){
			var ret = [];
			if (data && data.content) {
				ret.push({
					'url': data.content.videoID,
					'extra': data.content
				});
			}
			msgFormater({
				'data':ret,
				'message':msgtype,
				'service':'vevo'
			});
		}

		// @param: url: Url do ajax
		//         msgtype: tipo de mensagem
		//         config: serviço,dir,refer
		var ajax = function(url,msgtype,callback,service) {
			var xmlhttp = new XMLHttpRequest();
			xmlhttp.onreadystatechange = function() {
				if (xmlhttp.readyState == 4 && xmlhttp.status == 200) {
					var data = JSON.parse(xmlhttp.responseText);
					if(callback){
						callback(data,msgtype);
					}
				} else if (xmlhttp.readyState == 4 && xmlhttp.status != 200) {
					var obj = {
						'status' : 'error',
						'message': msgtype
					}
					if (service) obj['service'] = service;
					postMessage(obj);
				}
			}
			// throw JSON.stringify({oi:url})
			xmlhttp.open("GET", url, true);
			xmlhttp.send();
		}

		// @param: data: resposta ajax 
		//         msgtype: tipo de mensagem
		//         service: servico que foi requisitado
		var msgFormater = function(obj){
			// TODO: condicional retorno do PHP, status e conteudo
			postMessage({
				'content':obj.data,
				'message':obj.message,
				'service':obj.service,
				'status':'ok'
			});
		}

		onmessage = function(e){
			var data = e.data
			switch(data.message){
				case 'searchMore':
					search(data);
				break;
				case 'search':
					search(data);
				break;
				case 'imagesAlbum':
				case 'urlAlbum':
					album(data);
				break;
				case 'imagesGallery':
					gallery(data);
				break;
				case 'getSubtitle':
					subtitle(data);
				break;
				case 'getValidSource':
					getValidSource(data);
				break;
				case 'searchAndChange':
					getValidSource(data);
				break;
				case 'getRelatedSong':
					getRelatedSong(data);
				break;
			}
		};

		// Polyfill do FormData Upload para WebWorkers.
		(function() {
			// Export variable to the global scope
			(this == undefined ? self : this)['FormData'] = FormData;

			var ___send$rw = XMLHttpRequest.prototype.send;
			XMLHttpRequest.prototype['send'] = function(data) {
				if (data instanceof FormData) {
					if (!data.__endedMultipart) data.__append('--' + data.boundary + '--\r\n');
					data.__endedMultipart = true;
					this.setRequestHeader('Content-Type', 'multipart/form-data; boundary=' + data.boundary);
					data = new Uint8Array(data.data);
				}
				// Invoke original XHR.send
				return ___send$rw.call(this, data);
			};

			function FormData() {
				// Force a Constructor
				if (!(this instanceof FormData)) return new FormData();
				// Generate a random boundary - This must be unique with respect to the form's contents.
				this.boundary = '------RWWorkerFormDataBoundary' + Math.random().toString(36);
				var internal_data = this.data = [];
				/**
				* Internal method.
				* @param inp String | ArrayBuffer | Uint8Array  Input
				*/
				this.__append = function(inp) {
					var i=0, len;
					if (typeof inp === 'string') {
						for (len=inp.length; i<len; i++)
							internal_data.push(inp.charCodeAt(i) & 0xff);
					} else if (inp && inp.byteLength) {/*If ArrayBuffer or typed array */
						if (!('byteOffset' in inp))   /* If ArrayBuffer, wrap in view */
							inp = new Uint8Array(inp);
						for (len=inp.byteLength; i<len; i++)
							internal_data.push(inp[i] & 0xff);
					}
				};
			}
			/**
			* @param name     String                                  Key name
			* @param value    String|Blob|File|Uint8Array|ArrayBuffer Value
			* @param filename String                                  Optional File name (when value is not a string).
			**/
			FormData.prototype['append'] = function(name, value, filename) {
				if (this.__endedMultipart) {
					// Truncate the closing boundary
					this.data.length -= this.boundary.length + 6;
					this.__endedMultipart = false;
				}
				var valueType = Object.prototype.toString.call(value),
					part = '--' + this.boundary + '\r\n' + 
						'Content-Disposition: form-data; name="' + name + '"';

				if (/^\[object (?:Blob|File)(?:Constructor)?\]$/.test(valueType)) {
					return this.append(
						name,
						new Uint8Array(new FileReaderSync().readAsArrayBuffer(value)),
						filename || value.name
					);
				} else if (/^\[object (?:Uint8Array|ArrayBuffer)(?:Constructor)?\]$/.test(valueType)) {
					part += '; filename="'+ (filename || 'blob').replace(/"/g,'%22') +'"\r\n';
					part += 'Content-Type: application/octet-stream\r\n\r\n';
					this.__append(part);
					this.__append(value);
					part = '\r\n';
				} else {
					part += '\r\n\r\n' + value + '\r\n';
				}
				this.__append(part);
			};
		})();
	}
})(window.vPlayer.webworker)

/*
* mobile-vplayer-youtube.js
*/

var postMessenger = {
	objectMap: {}
	,   returnMap: {}
	,   returnID: 0
	,   callFunction : function(windowObject, objectName, methodName, arg1, arg2, argN, cb) {
		var args = Array.prototype.slice.call(arguments)
		,   win  = args.shift()
		,   callback = args.pop();

		if(typeof(win) == 'string') {
			win = document.querySelector(win);
			if(win) {
				win = win.contentWindow;
			}
		}

		if(win) {
			var id = this.returnID = ((this.returnID + 1) % 10000);
			win.postMessage({
				type: 'callFunction',
				args: args,
				id: id
			}, '*');

			this.returnMap[id] = callback;
		}

		setTimeout(function() {
			if (typeof(callback) == 'function') {
				callback(false, 'NO_WINDOW');				
			}
		}, 1);
	},
	init: function() {
		var that = this;
		window.addEventListener('message', function(event) {
			if(event.data.type) {
				if(event.data.type == 'callFunction') {
					var args = event.data.args
					,   objectName = args.shift()
					,   methodName = args.shift()
					,   id         = event.data.id
					,   error      = null
					,   result     = false;

					if(that.objectMap[objectName]) {
						if(that.objectMap[objectName][methodName]) {
							result = objectMap[objectName][methodName].apply(that.objectMap[objectName], args)	
							if(typeof(result) == 'object') {
								result = false;
							}
						} else {
							error = 'NO_FUNCTION';
						}
					} else {
						error = 'NO_OBJECT';
					}

					event.source.postMessage({
						id: id,
						result: result || null,
						type: 'returnFunction',
						error: error
					}, '*');
				} else if (event.data.type == 'returnFunction') {
					var cb = that.returnMap[event.data.id];
					if (typeof(cb) == 'function') {
						cb(event.data.result, event.data.error);						
					}
					delete that.returnMap[event.data.id];
				}
			}
		}, false);
	},
	registerObject: function(name, object) {
		this.objectMap[name] = object;
	}
}

window.vPlayer = window.vPlayer || {};
window.vPlayer.youtube = window.vPlayer.youtube || {};

(function(v){

	v.Init = function (player) {
		var sourceIndex = 0
		,   isChrome = navigator.userAgent.toLowerCase().indexOf('chrome') > 0
		,   instance = {}
		,   notFirstPlay = false
		,   isPlaying = false;

		// Definir os eventos que vem do mediaElement
		var defineEvents = function(media) {
			var target = document.getElementById(player.id);

			clearEvents(media);
			player.modules.watch(media, 'pause.youtube', function() {
				player.modules.fire(target, 'pause.core');
			})
			player.modules.watch(media, 'progress.youtube', function(e, percent) {
				player.modules.fire(target, 'buffering.core');
			})
			player.modules.watch(media, 'timeupdate.youtube', function(e,currentTime,duration) {
				player.modules.fire(target, 'timeupdate.youtube', {'detail': [currentTime,duration]});
			})
			player.modules.watch(media, 'play.youtube', function() {
				player.modules.fire(target, 'play.core');
			})
			player.modules.watch(media, 'ended.youtube', function() {
				player.modules.fire(target, 'ended.core');
			})
			player.modules.watchOnce(media, 'playing.youtube', function() {
				isPlaying = true;
				player.modules.fire(target, 'playing.core');
				player.modules.off(player.instances.mediaYoutube, 'playing.youtube');
			})
			player.modules.watch(media, 'canplay.youtube', function() {
				player.modules.fire(target, 'canplay.core');
			})
			player.modules.watch(media, 'error.youtube', function(e,error) {
				notFirstPlay = true;
				if(player.modules.getObjSong().source[sourceIndex + 1]){
					sourceIndex++;
					//that.startYoutubeConf();
				}
			})
			player.modules.watch(media, 'buffering.youtube', function() {
				player.modules.fire(target, 'buffering.core');	
			})
		}

		var clearEvents = function(obj) {
			player.modules.off(obj, 'pause.youtube');
			player.modules.off(obj, 'progress.youtube');
			player.modules.off(obj, 'timeupdate.youtube');
			player.modules.off(obj, 'play.youtube');
			player.modules.off(obj, 'ended.youtube');
			player.modules.off(obj, 'playing.youtube');
			player.modules.off(obj, 'canplay.youtube');
			player.modules.off(obj, 'error.youtube');
		}

		this.loadOtherVideoByError = function() {
			var objValid = new player.modules.objValidSourceAndCount();
		}

		this.loadPlayer = function() {
			player.modules.getObjSong().source = player.modules.getObjSong().source.split(',');
			sourceIndex = 0;
			this.startYoutubeConf();
		}

		// função que inicia o youtube
		this.startYoutubeConf = function() {
			// Inicio da estancia
			var target          = player.target
			,   instanceYoutube = player.instances.mediaYoutube
			,   song            = player.modules.getObjSong().source[sourceIndex];

			if (document.querySelector('.vContentYoutube')) {
				player.front.hide();
				player.front.show('youtube');
				instanceYoutube.setSrc(song);
			} else {
				// Atualiza o html do source
				player.front.render({action:'contentPlayer'})

				// Instanciando o objeto do MediaElemnt
				instanceYoutube = confYoutubePlayer('playerYoutube_'+player.id,song);
				player.instances.mediaYoutube = instanceYoutube;
				// Definir eventos
				defineEvents(this);
			}
		}

		this.isPlaying = function () {
			return isPlaying ? true : false;
		}

		this.play = function () {
			var data = player.instances.mediaYoutube
			data && data.play()
		}

		this.pause = function () {
			var data = player.instances.mediaYoutube;
			isPlaying = false;
			data && data.pause()
		}

		this.stop = function () {
			var media = player.instances.mediaYoutube
			if (media) {
				media.stop();
				isPlaying = false;
			}
			// Tem que dar o off pois o evento de progress não termina
			media.removeEventListener('.youtube');
		}

		this.setVolume = function(vol) {
			var data = player.instances.mediaYoutube
			data && data.setVolume(vol)
		}

		this.getVolume = function(vol) {
			var data = player.instances.mediaYoutube
			return data ? data.getVolume() : false;
		}

		this.setProgressbar = function(time) {
			var data = player.instances.mediaYoutube
			data && data.setCurrentTime(time)
		}

		this.getDuration = function() {
			var data = player.instances.mediaYoutube
			return data ? data.getDuration() : false;
		}

		this.getAllVideoQuality = function() {
			return player.instances.mediaYoutube.playerInstance.getAvailableQualityLevels();
		}

		this.getVideoQuality = function() {
			return player.instances.mediaYoutube.playerInstance.getPlaybackQuality();
		}

		this.setVideoQuality = function(quality) {
			if (quality == "auto") quality = "default"
			return player.instances.mediaYoutube.playerInstance.setPlaybackQuality(quality);
		}

		// Função para verificar se o script do youtube já está carregado
		var isLoadedScript = function() {
			return document.querySelectorAll('script[src="https://www.youtube.com/iframe_api"]').length ? true : false;
		}

		// Funções que instancia o youtube
		var loadingScriptYoutube = false
		,   loadedScript         = isLoadedScript()
		,   testInstance         = this
		,   queueLoadingYoutube  = []
		,   confYoutubePlayer = function(target,ytID) {

			// Função inicial do youtube
			var initYoutube = function() {
				// Caso ainda esteja carregando o script
				if (loadingScriptYoutube) {
					queueLoadingYoutube.push(objInstance);
					return;
				}

				// Caso o youtube já esteja carregado
				if (loadedScript) {
					// Instancia o player
					onYoutubeReady(objInstance);
				} else {
					// Carregando o script do youtube
					var tag = document.createElement('script');
					tag.src = 'https://www.youtube.com/iframe_api';

					var firstScriptTag = document.getElementsByTagName('script')[0];
					firstScriptTag.parentNode.insertBefore(tag,firstScriptTag);

					loadingScriptYoutube = true;
				}
			}

			// Instancia do player
			var objInstance = {}
			objInstance.ytID = ytID;
			objInstance.target = target;

			// Objeto de configuração do player
			var playerConf = {
				egm            : 0,
				iv_load_policy : 3,
				showinfo       : 0,
				real           : 0,
				enablejsapi    : 1,
				autoplay       : player.defaults.autoPlay ? 1 : 0,
				wmode          : "transparent",
				controls       : player.defaults.controls ? 1 : 0
			}

			var ytAdsInterval = false
			,   ytBufferingTimeout = false
			,   ytNotPlayed = false
			,   ytAds = false;

			var onErrorHandler = function(e) {
				// 5 The requested content cannot be played in an HTML5 player or another error related to the HTML5 player has occurred.
				// Error 5 ta disparando para videos novos porém é possivel tocar
				if (e && e.data == 5) {
					// Google Analytics
					var song = player.modules.getObjSong();
					mobile.analyticsEvents('vPlayer / Error 5 Youtube', player.defaults.currentSong.source);
				} else {
					player.modules.getValidSource();
				}
			}

			// Função que executa o buffering
			var intervalProgress = false
			,   progressBuffering = function(instance) {
				clearInterval(intervalProgress);

				intervalProgress = setInterval(function(){
					try {
						postMessenger.callFunction('#iframeYoutube', 'youtubePlayer', 'getVideoLoadedFraction', function(value) {
							if (value) {
									if (value == 1 || instance.state == 'ended') {
									clearInterval(intervalProgress);
								}
								var percent = value * 100;

								player.modules.fire(instance, 'progress.youtube', {'detail': [percent]});
							}
						});
					} catch(e) {}
				},800)
			}

			// Função que executa o currentTime
			var intervalCurrentTime = false
			,   progressCurrentTime = function(instance) {
				clearInterval(intervalCurrentTime);

				intervalCurrentTime = setInterval(function(){
					if (instance.state == 'playing') {
						if (instance.state == 'ended') {
							clearInterval(intervalCurrentTime);
						}
						try {
							player.modules.fire(instance, 'timeupdate.youtube');
						} catch(e) {}
					}
				},100)
			}

			// Funções que serão retornadas por objeto

			// Função para dar o play no video
			objInstance.play = function() {
				postMessenger.callFunction('#iframeYoutube', 'youtubePlayer', 'playVideo', 0);
			}

			// Função para dar o pause no video
			objInstance.pause = function() {
				postMessenger.callFunction('#iframeYoutube', 'youtubePlayer', 'pauseVideo', 0);
			}

			objInstance.stop = function() {
				try {
					postMessenger.callFunction('#iframeYoutube', 'youtubePlayer', 'stopVideo', 0);
					postMessenger.callFunction('#iframeYoutube', 'youtubePlayer', 'clearVideo', 0);

					// Limpando o interval para não ter problemas
					clearInterval(intervalCurrentTime);
					clearInterval(intervalProgress);
				} catch(e){}
			}

			// Função para setar o volume
			objInstance.setVolume = function(vol) {
				postMessenger.callFunction('#iframeYoutube', 'youtubePlayer', 'setVolume', (vol * 100), 0);
			}

			// Função para pegar o volume
			objInstance.getVolume = function(cb) {
				postMessenger.callFunction('#iframeYoutube', 'youtubePlayer', 'getVolume', function(vol) {
					cb(vol);
				});
			}

			// Função para pegar o duration
			objInstance.getDuration = function(cb) {
				postMessenger.callFunction('#iframeYoutube', 'youtubePlayer', 'getDuration', function(duration) {
					cb(duration);
				});
			}

			// Função para pegar o tempo da música
			objInstance.getCurrentTime = function(cb) {
				postMessenger.callFunction('#iframeYoutube', 'youtubePlayer', 'getCurrentTime', function(currentTime) {
					cb(currentTime);
				});
			}

			// Função para pegar o tempo da música
			objInstance.setCurrentTime = function(time) {
				postMessenger.callFunction('#iframeYoutube', 'youtubePlayer', 'seekTo', time, 0);
			}

			// Carrega outro video
			objInstance.setSrc = function(ytID) {
				try {
					if(player.defaults.isPhone) {
						postMessenger.callFunction('#iframeYoutube', 'youtubePlayer', 'cueVideoById', ytID, 0, 0);
					} else {
						//objInstance.playerInstance.loadVideoById(ytID,0);
						postMessenger.callFunction('#iframeYoutube', 'youtubePlayer', 'cueVideoById', ytID, 1, 0);

						if(!isChrome || notFirstPlay){
							postMessenger.callFunction('#iframeYoutube', 'youtubePlayer', 'playVideo', 0);
						}
					}
					objInstance.ytID = ytID;
				} catch(e) {}
			}

			// Função chamada depois que o youtube retorna que já carregou o script
			objInstance.initYoutubeByIframeAPIReady = function() {
				// Inicia o youtube
				onYoutubeReady(objInstance);

				if (queueLoadingYoutube.length) {
					for (var x=0,xx=queueLoadingYoutube.length;x<xx;x++) {
						onYoutubeReady(queueLoadingYoutube[x]);
					}
				}
			}

			var that = this;
			window.addEventListener("message", function(event) {
				switch(event.data) {
					case 'playing':						
						instance.state = 'playing';
						player.modules.fire(testInstance, 'play.youtube')
						player.modules.fire(testInstance, 'playing.youtube')

						ytNotPlayed = true;
						notFirstPlay = true;
						clearInterval(ytAdsInterval);
						if (ytAds) {
							player.modules.fire(testInstance, 'endads.youtube')
							ytAds = false
						}

						new player.modules.objValidSourceAndCount().clear();
						break;
					case 'ended':
						instance.state = 'ended';
						player.modules.fire(testInstance, 'ended.youtube');
						break;
					case 'buffering':
						instance.state = 'buffering';
						player.modules.fire(testInstance, 'buffering.youtube')

						if (!ytNotPlayed) {
							ytAdsInterval = setInterval(function(){
								if (that.state == "buffering" && that.getCurrentTime()) {
									player.modules.fire(testInstance, 'startads.youtube')

									ytAds = true;
									clearInterval(ytAdsInterval);
								}
							},1000)
						}
						break;
					case 'paused':
						instance.state = 'pause';
						player.modules.fire(testInstance, 'pause.youtube')
						break;
					case 'ready':
						postMessenger.init();
						instance.state = 'canplay';

						player.modules.fire(testInstance, 'canplay.youtube');

						// Progress do buffering
						progressBuffering(testInstance);

						// Progress do currentTime
						progressCurrentTime(testInstance);
						break;
				}
			}, false);

			// Inicia o processo de inserir o script do youtube
			initYoutube();

			return objInstance;
		}

		// Chamada para carregar o youtube
		this.loadPlayer()
	}

})(window.vPlayer.youtube);
